//+------------------------------------------------------------------+
//|                                                BreakoutHedge.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property show_inputs

//#include <stdlib.mqh>
#import "stdlib.ex4"
   string ErrorDescription(int a0);
#import

extern string Note = "*** RS2010 ***";
extern string Note4 = "---------------------------------------------------------------------";
extern int MagicNumber = 0;
extern string Mode = "normal";
extern string Note5 = "----- CLOSE ALL POSITION -----";
extern bool CloseAll = FALSE;
extern string Note6 = "----- BASIC PARAMETER -----";
extern int EALoop = 0;
extern double LotSize = 0.5;
extern bool CloseOneCloseAll = TRUE;
extern bool AutoCalculateLot = FALSE;
extern bool OnlyAllowDecreaseLot = TRUE;
extern double LotEquityRatio = 1.0;
extern int CloseWhileHedgingProfit = 10;
extern string Note7 = "----- INCREMENTAL RANGE -----";
extern int increase = 15;
extern int IncreaseStartLevel = 2;
extern int IncreaseEndLevel = 7;
extern string Note8 = "----- HEDGING STRATEGY -----";
extern bool Hedging = TRUE;
extern int HedgeGap = 23;
extern double Multiplier = 0.0;
extern int TakeProfit = 150;
extern int StopLoss = 0;
extern bool GapAdjustment = FALSE;
extern string Note9 = "----- AVERAGING STRATEGY -----";
extern bool Averaging = FALSE;
extern int AveragingHedgeGap = 20;
extern double AveragingMultiplier = 2.0;
extern int AveragingTakeProfit = 50;
extern int AveragingStopLoss = 0;
extern double MaxLotStop = 0.0;
extern bool StartFromHiLow = FALSE;
extern int MinimumHiLowRange = 130;
extern int RangeFromHiLow = 5;
extern int HiLowIndicatorLevel = 0;
bool gi_272 = FALSE;
double gd_276 = 6.0;
double gd_284 = 20.0;
string gs_buy_292 = "buy";
string gs_eurusd_300 = "EURUSD";
string gs_usdchf_308 = "USDCHF";
bool gi_316 = FALSE;
bool gi_320 = FALSE;
bool gi_324 = TRUE;
double g_str2dbl_328 = 0.0;
int gi_336 = 10;
int gi_340 = 20;
int gi_344 = 0;
int gi_348 = 8;
int gi_352 = 3;
int gi_356 = 15;
int gi_360 = 10;
extern string Note12 = "----- INITIAL ORDER -----";
extern string InitialOrder = "sa";
extern int ShortEMA = 5;
extern int LongEMA = 14;
extern string Note13 = "----- START WITH STRADDLE -----";
extern bool Straddle = FALSE;
extern int StraddleRange = 8;
extern double StraddleBuyPrice = 0.0;
extern double StraddleSellPrice = 0.0;
extern int StraddleTakeProfit = 20;
extern int StraddleStopLoss = 0;
extern string Note14 = "----- TRAILING STOP -----";
extern int TrailingStop = 23;
extern int TrailingStopStartLevel = 1;
extern int TrailingStopEndLevel = 3;
extern int Rebound = 3;
extern string Note15 = "----- TRAILING STOP 2-----";
extern int TrailingStop_2 = 17;
extern int TrailingStop_2_StartLevel = 2;
extern int TrailingStop_2_EndLevel = 4;
extern int Rebound_2 = 2;
extern string Note16 = "----- TRAILING STOP 3-----";
extern int TrailingStop_3 = 11;
extern int TrailingStop_3_StartLevel = 3;
extern int TrailingStop_3_EndLevel = 6;
extern int Rebound_3 = 2;
extern string Note17 = "----- TRAILING STOP 4-----";
extern int TrailingStop_4 = 2;
extern int TrailingStop_4_StartLevel = 4;
extern int TrailingStop_4_EndLevel = 0;
extern int Rebound_4 = 1;
extern string Note18 = "----- MONEY MANAGEMENT -----";
extern double MaxRiskPercentage = 100.0;
extern double MaxProfit = 0.0;
extern double MaxLoss = 0.0;
extern int MaxLevelAllowed = 0;
extern string Note19 = "----- DOUBLER -----";
extern bool Doubler = FALSE;
extern bool DisableTrailingStop = FALSE;
extern double DoublerLotSize = 0.1;
extern int DoublerRangeFromProfit = 10;
extern int DoublerTakeProfit = 10;
extern int DoublerStopLoss = 10;
extern double DoublerMultiplier = 0.0;
extern double DoublerAddition = 0.1;
extern int DoublerStartLevel = 1;
extern int DoublerEndLevel = 0;
extern int DoublerMaxOrder = 1;
extern string Note20 = "----- TIME -----";
extern string StartEATime = "0";
extern string EndEATime = "0";
extern string StopLoopTime = "0";
bool gi_656 = TRUE;
bool gi_660 = FALSE;
bool gi_664 = TRUE;
bool gi_unused_668 = TRUE;
bool gi_unused_672 = TRUE;
bool gi_676 = FALSE;
bool gi_680 = FALSE;
bool gi_684 = TRUE;
bool gi_688 = FALSE;
bool gi_692 = FALSE;
int gi_unused_696 = 0;
int g_count_700;
int g_count_704;
int g_count_708;
int g_count_712;
int gi_716 = 0;
int gi_720 = 0;
int gi_724;
int g_error_728;
int g_order_total_732;
int g_pos_736;
int gi_740 = 1;
int gi_744 = 0;
int gi_748 = 0;
double gd_752;
double gd_760;
double g_order_lots_768;
double g_order_lots_776;
double gd_784 = 0.0;
double gd_792 = 0.0;
double gd_800;
double gd_808;
double gd_816 = 0.0;
double gd_824 = 0.0;
double gd_832 = 0.0;
double gd_840 = 0.0;
double gd_848 = 0.0;
double gd_856 = 0.0;
double g_order_open_price_864 = 0.0;
double g_order_open_price_872 = 0.0;
double gd_unused_880 = 0.0;
double gd_unused_888 = 0.0;
double gd_896;
double gd_904;
double gd_912;
double gd_920;
double gd_928 = 0.0;
double gd_936 = 0.0;
double gd_unused_944 = 0.0;
double gd_unused_952 = 0.0;
double gd_960 = 0.0;
double gd_968 = 0.0;
double gd_976 = 0.0;
double gd_984;
double gd_992;
double gd_1000;
double gd_1008;
double gd_1016;
double gd_1024;
double gd_1032;
double gd_1040;
double gd_1048;
double gd_1056;
double gd_1064;
double gd_1072;
double gd_1080;
double gd_1088;
double gd_1096;
double gd_1104;
double gd_1112;
double gd_1120;
double gd_1128;
double gd_1136;
double gd_1144;
double gd_1152;
double gd_1160;
double gd_1168;
double gd_1176;
double gd_1184;
double gd_1192;
double gd_1200;
double gd_1208;
double gd_1216;
double gd_1224;
double gd_1232;
double gd_1240;
double gd_1248;
double gd_1256;
double gd_1264;
double gd_1272;
double gd_1280;
double g_lots_1288;
double g_lots_1296;
double g_order_open_price_1304;
double g_order_open_price_1312;
double g_order_lots_1320;
double g_order_lots_1328;
int g_count_1336;
int g_count_1340;
bool gi_1344;
bool gi_1348;
bool gi_1352;
double g_order_lots_1356;
double g_order_lots_1364;
double gd_1372;
double gd_1380;
double g_price_1388;
double g_price_1396;
double g_price_1404;
double g_price_1412;
double gd_1420;
double gd_1428;
double gd_1436;
double gd_1444;
double gd_1452;
double g_order_open_price_1460;
double g_order_open_price_1468;
double g_price_1476;
double g_price_1484;
double g_price_1492;
double g_price_1500;
double gd_1508;
double gd_1516;
double g_order_open_price_1524;
double g_order_open_price_1532;
double gd_1540;
double gd_1548;
double g_order_open_price_1556;
double g_order_open_price_1564;
double gd_1580;
double gd_1588;
double gd_1596;
double gd_1604;
double gd_1612;
double gd_1620;
double g_high_1628;
double g_low_1636;
double g_order_open_price_1644;
double g_order_open_price_1652;
double gd_1660;
double gd_1668;
int g_file_1676;
int g_file_1680;
int gi_1684;
string gs_unused_1688 = "Color Settings";
string gs_1696 = "";
int g_magic_1704 = 2345;
string gs_unused_1708 = "2050.01.01 23:59";
int gi_unused_1716 = 219517;
string gs_dummy_1720;
string gs_dummy_1728;
string gs_dummy_1736;
string gs_dummy_1744;
string gs_1752;
string gs_unused_1760;
string gs_unused_1768;
string gs_unused_1776;
string gs_1784;
string g_name_1792 = "initialbalance.txt";
string gs_dummy_1800;
int gi_unused_1808;
int gi_1812;
int gi_1816;
int gi_unused_1820;
int gi_unused_1824;
double gd_1828;
double gd_1836;
double gd_1844;
double gd_1860;
double g_order_open_price_1868;
double g_order_open_price_1876;
double gd_1884;
double gd_1892;
double gd_1900;
double g_lots_1908;
double gd_1916;
double gd_1924;
double gd_1932;
double gd_1940;
double gd_1948;
double g_price_1956;
double g_price_1964;
double g_price_1972;
double g_price_1980;
double g_str2dbl_1988;
double gd_1996;
double g_order_open_price_2004;
double g_order_open_price_2012;
double g_order_stoploss_2020;
double g_order_stoploss_2028;
double gd_2036;
double gd_2044;
double gd_2052;
double gd_2060;
double gd_2068;
double gd_2076;
double gd_2084;
double gd_2092;
double gd_2100;
double gd_2108;
double gd_2116;
double gd_2124;
double gd_2132;
double gd_2140;
double gd_2148;
double g_lots_2156;
double g_lots_2164;
double gd_2172;
double gd_2180;
bool gi_2188;
bool gi_2192 = TRUE;
double g_order_open_price_2196;
double gd_2204;
double gd_2212;
double g_price_2220;
double g_price_2228;
double g_order_open_price_2236;
double gd_2244;
double gd_2252;
double g_price_2260;
double g_price_2268;
double gd_2276;
double gd_2284;
double gd_2292;
double gd_2300;
double gd_2308;
string gs_unused_2316;
string gs_unused_2324;
int gi_unused_2332 = 65535;
int gi_unused_2336 = 16760576;
int gi_unused_2340 = 3329330;
int gi_unused_2344 = 14772545;
int gi_unused_2348 = 255;
int gi_unused_2352 = 55295;
int gi_unused_2356 = 16443110;
int gi_unused_2360 = 9221330;
int gi_unused_2364 = 8388352;
int gi_unused_2368 = 13499135;
int gi_unused_2372 = 11119017;
int gi_unused_2376 = 0;
int gi_unused_2380 = 0;
int gi_unused_2384 = 20;
int gi_unused_2388 = 35;
int gi_unused_2392 = 50;
int gi_unused_2396 = 65;
int gi_unused_2400 = 80;
int gi_unused_2404 = 95;
int gi_unused_2408 = 110;
int gi_unused_2412 = 125;
int gi_unused_2416 = 140;
int gi_unused_2420 = 155;
int gi_unused_2424 = 170;
int gi_unused_2428 = 185;
int gi_unused_2432 = 200;
int gi_unused_2436 = 215;
int gi_unused_2440 = 230;
int gi_unused_2444 = 245;
int gi_unused_2448 = 260;
int gi_unused_2452 = 275;
int gi_unused_2456 = 290;
int gi_unused_2460 = 305;
int gi_unused_2464 = 320;
int gi_unused_2468 = 335;
int gi_unused_2472 = 350;
int gi_unused_2476 = 365;
int gi_unused_2480 = 380;
int gi_2484 = 0;
int gi_2488 = 0;
int gi_2492 = 0;
double g_point_2496;
int gi_2504;
int gi_unused_2508 = 0;

int init() {
   g_point_2496 = MarketInfo(Symbol(), MODE_POINT);
   if (g_point_2496 == 0.00001 || g_point_2496 == 0.0001) gi_2504 = 4;
   if (g_point_2496 == 0.001) gi_2504 = 3;
   if (g_point_2496 == 0.01) gi_2504 = 2;
   return (0);
}

int start() {
   int file_0;
   if (AutoCalculateLot == TRUE) {
      if (gd_1900 != AccountBalance()) {
         gd_1900 = AccountBalance();
         Print(gd_1900);
         if (LotEquityRatio > 0.0) gd_1884 = gd_1900 * LotEquityRatio;
         else gd_1884 = gd_1900;
         if (MarketInfo(Symbol(), MODE_MINLOT) == 1.0) {
            if (gd_1884 >= 100000.0) gd_1892 = MathRound(0.00001 * gd_1884);
            if (gd_1884 < 100000.0) gd_1892 = MarketInfo(Symbol(), MODE_MINLOT);
         }
         if (MarketInfo(Symbol(), MODE_MINLOT) == 0.1) {
            if (gd_1884 >= 100000.0) gd_1892 = MathRound(0.00001 * gd_1884);
            if (gd_1884 < 100000.0 && gd_1884 >= 10000.0) gd_1892 = MathRound(gd_1884 / 10000.0) / 10.0;
            if (gd_1884 < 10000.0) gd_1892 = MarketInfo(Symbol(), MODE_MINLOT);
         }
         if (MarketInfo(Symbol(), MODE_MINLOT) == 0.01) {
            if (gd_1884 >= 100000.0) gd_1892 = MathRound(0.00001 * gd_1884);
            if (gd_1884 < 100000.0 && gd_1884 >= 10000.0) gd_1892 = MathRound(gd_1884 / 10000.0) / 10.0;
            if (gd_1884 < 10000.0 && gd_1884 >= 1000.0) gd_1892 = MathRound(gd_1884 / 1000.0) / 100.0;
            if (gd_1884 < 1000.0) gd_1892 = MarketInfo(Symbol(), MODE_MINLOT);
         }
         if (OnlyAllowDecreaseLot == FALSE)
            if (g_lots_1908 != gd_1892) g_lots_1908 = gd_1892;
         if (OnlyAllowDecreaseLot == TRUE)
            if (g_lots_1908 == 0.0 || g_lots_1908 > gd_1892) g_lots_1908 = gd_1892;
      }
   } else g_lots_1908 = LotSize;
   if (gi_316 == TRUE) {
      DisableTrailingStop = TRUE;
      Doubler = FALSE;
      CloseOneCloseAll = FALSE;
      StopLoopTime = "0";
   }
   if (Mode == "pyr") {
      LotSize = 0.2;
      AveragingHedgeGap = 10;
      AveragingMultiplier = 2;
      AveragingTakeProfit = 15;
      increase = 0;
      Hedging = FALSE;
      gi_272 = FALSE;
      Averaging = TRUE;
      MaxLotStop = 1;
      StartFromHiLow = TRUE;
      Mode = "pyramid";
   }
   gd_2204 = 0;
   gd_2244 = 0;
   gd_2212 = 0;
   gd_2252 = 0;
   g_price_2220 = 0;
   g_price_2260 = 0;
   g_price_2228 = 0;
   g_price_2268 = 0;
   g_order_lots_1356 = 0;
   g_order_lots_1364 = 0;
   gd_2068 = 0;
   gd_2076 = 0;
   gd_2100 = 0;
   gd_2108 = 0;
   gd_2116 = 0;
   gd_2124 = 0;
   gd_2292 = MarketInfo(Symbol(), MODE_POINT);
   if (MarketInfo(Symbol(), MODE_DIGITS) == 3.0 || MarketInfo(Symbol(), MODE_DIGITS) == 5.0) {
      gd_2308 = MarketInfo(Symbol(), MODE_STOPLEVEL) / 10.0;
      gd_2300 = 10.0 * gd_2292;
   } else {
      gd_2300 = gd_2292;
      gd_2308 = MarketInfo(Symbol(), MODE_STOPLEVEL);
   }
   if (gd_2284 < NormalizeDouble(Ask, gi_2504) - NormalizeDouble(Bid, gi_2504)) gd_2284 = NormalizeDouble(Ask, gi_2504) - NormalizeDouble(Bid, gi_2504);
   if (MaxRiskPercentage > 100.0) MaxRiskPercentage = 100.0;
   if (gd_1844 == 0.0) gd_1844 = AccountBalance();
   if (gi_320 == TRUE) {
      FileDelete(g_name_1792);
      g_error_728 = GetLastError();
      if (g_error_728 != 0/* NO_ERROR */) {
         Print("Error = ", ErrorDescription(g_error_728), " while deleting Balance Amount");
         gi_320 = FALSE;
         gi_656 = FALSE;
         return (0);
      }
      Print("Successfully Reseting Balance");
      gi_320 = FALSE;
   }
   if (g_str2dbl_328 > 0.0) {
      g_str2dbl_1988 = g_str2dbl_328;
      g_file_1676 = FileOpen(g_name_1792, FILE_CSV|FILE_WRITE);
      for (int count_4 = 0; count_4 < 1; count_4++) gi_1684 = FileWrite(g_file_1676, DoubleToStr(g_str2dbl_328, 2));
      if (gi_1684 > 0) {
         Print("InitialBalance is ", g_str2dbl_1988);
         g_str2dbl_328 = 0;
         Print("MSInitialBalance= ", DoubleToStr(g_str2dbl_328, 2));
      } else {
         Print("Failed setting InitialBalance");
         gi_656 = FALSE;
         return (0);
      }
      FileClose(g_file_1676);
   } else {
      if (gd_1948 != AccountBalance()) {
         file_0 = FileOpen(g_name_1792, FILE_CSV|FILE_READ);
         gd_1948 = AccountBalance();
         if (file_0 > 0) {
            gs_1784 = FileReadString(file_0);
            FileClose(file_0);
            g_str2dbl_1988 = StrToDouble(gs_1784);
         }
         if (file_0 < 0) {
            g_file_1680 = FileOpen(g_name_1792, FILE_CSV|FILE_WRITE);
            if (g_file_1680 > 0) {
               for (count_4 = 0; count_4 < 1; count_4++) FileWrite(g_file_1680, DoubleToStr(gd_1948, 2));
               FileClose(g_file_1680);
               g_str2dbl_1988 = AccountBalance();
            }
            if (g_file_1680 < 0) {
               Print("File Error. Closing Expert Advisor.");
               gi_656 = FALSE;
               return (0);
            }
         }
      }
   }
   if (TimeCurrent() < StrToTime(StartEATime)) {
      gi_656 = FALSE;
      gi_680 = TRUE;
      if (f0_11() + f0_8() > 0) f0_21();
   }
   if (gi_684 == TRUE) {
      if (TimeCurrent() >= StrToTime(StartEATime)) {
         if (EndEATime > "0" && TimeCurrent() >= StrToTime(EndEATime)) {
            gi_656 = FALSE;
            gi_684 = FALSE;
            f0_2();
            gs_1696 = "EndEATime";
         }
         if (EndEATime > "0" && TimeCurrent() < StrToTime(EndEATime)) {
            gi_680 = FALSE;
            gi_684 = FALSE;
            gi_656 = TRUE;
         }
      }
   }
   if ((Hedging == TRUE && Averaging == TRUE) || (Hedging == TRUE && gi_316 == TRUE) || (Hedging == TRUE && gi_272 == TRUE) || (Averaging == TRUE && gi_272 == TRUE) ||
      (Averaging == TRUE && gi_316 == TRUE)) {
      gi_unused_1820 = 1;
      gi_656 = FALSE;
   }
   if (AccountBalance() < MarketInfo(Symbol(), MODE_MARGINREQUIRED) * MarketInfo(Symbol(), MODE_MINLOT) + MarketInfo(Symbol(), MODE_SPREAD) * MarketInfo(Symbol(), MODE_TICKVALUE) * MarketInfo(Symbol(),
      MODE_MINLOT)) {
      gi_unused_1824 = 1;
      gi_656 = FALSE;
   }
   if (gi_656 == TRUE) {
      if (!IsExpertEnabled()) gi_unused_1808 = 1;
   } else {
      if (gi_680 == TRUE) {
      }
      if (gi_680 == FALSE)
         if (gi_1352 == FALSE) gi_1352 = TRUE;
   }
   if (gi_656 == TRUE) {
      if (MarketInfo(Symbol(), MODE_DIGITS) == 3.0 || MarketInfo(Symbol(), MODE_DIGITS) == 5.0) {
         gd_2172 = MarketInfo(Symbol(), MODE_SPREAD) / 10.0;
         gd_2180 = MarketInfo(Symbol(), MODE_STOPLEVEL) / 10.0;
      } else {
         gd_2172 = MarketInfo(Symbol(), MODE_SPREAD);
         gd_2180 = MarketInfo(Symbol(), MODE_STOPLEVEL);
      }
      gd_1860 = (MarketInfo(Symbol(), MODE_HIGH) - MarketInfo(Symbol(), MODE_LOW)) / MarketInfo(Symbol(), MODE_POINT);
   }
   if (Averaging == TRUE && StartFromHiLow == TRUE) {
      if (f0_29() + f0_17() > 0) gi_2188 = FALSE;
      else gi_2188 = TRUE;
   }
   if (Straddle == FALSE && gi_2188 == FALSE) {
      if (gi_316 != TRUE) {
         if (InitialOrder == "auto" || InitialOrder == "m" || InitialOrder == "manual" || InitialOrder == "buy auto" || InitialOrder == "sell auto" || InitialOrder == "ba" ||
            InitialOrder == "sa") {
            if (InitialOrder == "m") InitialOrder = "manual";
            if (InitialOrder == "a") InitialOrder = "auto";
            if (InitialOrder == "ba") InitialOrder = "buy auto";
            if (InitialOrder == "sa") InitialOrder = "sell auto";
         }
      }
      if (AutoCalculateLot == TRUE) {
         gs_unused_1760 = "ON";
         if (OnlyAllowDecreaseLot == TRUE) gs_unused_1768 = "ON";
         else gs_unused_1768 = "OFF";
      } else gs_unused_1760 = "OFF";
      if (CloseOneCloseAll == TRUE) gs_unused_1776 = "ON";
      else gs_unused_1776 = "OFF";
   }
   if (CloseAll == TRUE) {
      gi_656 = FALSE;
      f0_2();
      CloseAll = FALSE;
      gs_1696 = "Manual";
      return (0);
   }
   if (StopLoss < 0) StopLoss = 0;
   if (g_lots_1908 < MarketInfo(Symbol(), MODE_MINLOT)) g_lots_1908 = MarketInfo(Symbol(), MODE_MINLOT);
   if (gi_676 == TRUE) gi_656 = FALSE;
   if (gi_656 == TRUE) {
      if (StopLoopTime > "0" && TimeCurrent() > StrToTime(StopLoopTime))
         if (EALoop > 0 && gi_740 != EALoop) gi_740 = EALoop;
      if (MaxLevelAllowed > 0) {
         if (Averaging == TRUE) {
            if (gi_1812 > gi_1816) {
               if (gi_1812 > MaxLevelAllowed) {
                  f0_2();
                  gs_1696 = "MaxLevelAllowed";
               }
            }
            if (gi_1816 > gi_1812) {
               if (gi_1816 > MaxLevelAllowed) {
                  f0_2();
                  gs_1696 = "MaxLevelAllowed";
               }
            }
         } else {
            if (gi_744 > MaxLevelAllowed) {
               f0_2();
               gs_1696 = "MaxLevelAllowed";
            }
         }
      }
      if (MaxRiskPercentage > 0.0) {
         gd_1420 = 100.0 * ((AccountEquity() - AccountBalance()) / AccountBalance());
         if (gd_1420 <= -MaxRiskPercentage) {
            f0_2();
            gs_1696 = "MaxRiskPercentage";
         }
      }
      if (MaxLoss > 0.0) {
         if (AccountProfit() <= -MaxLoss) {
            f0_2();
            gs_1696 = "MaxLoss";
         }
      }
      if (gi_664 == TRUE) {
         if (gi_1348 == FALSE) {
            if (f0_11() + f0_8() > 0) f0_21();
            gi_1348 = TRUE;
         }
         if (Straddle == FALSE) {
            if (gi_316 == FALSE) {
               if (Hedging == TRUE) f0_18();
               if (Hedging == FALSE && Averaging == FALSE && gi_272 == FALSE) f0_18();
               if (gi_272 == TRUE) {
                  gi_664 = FALSE;
                  gi_660 = TRUE;
               }
               if (Averaging == TRUE && StartFromHiLow == FALSE) f0_18();
               if (Averaging == TRUE && StartFromHiLow == TRUE) {
                  if (f0_29() + f0_17() <= 0) {
                     gi_2188 = TRUE;
                     if (gd_1860 > MinimumHiLowRange) {
                        if (g_high_1628 == 0.0) g_high_1628 = MarketInfo(Symbol(), MODE_HIGH);
                        if (g_low_1636 == 0.0) g_low_1636 = MarketInfo(Symbol(), MODE_LOW);
                        gd_1620 = g_high_1628 + RangeFromHiLow * gd_2300 + gd_2284;
                        gd_1612 = g_low_1636 - RangeFromHiLow * gd_2300 - gd_2284;
                        if (f0_11() < 1) {
                           if (f0_28(OP_BUYLIMIT, g_lots_1908, gd_1612, 0, 0, "HiLow Buy Limit", MagicNumber) < 0) {
                              gd_1612 -= gd_2300;
                              Print("Error HiLow Buy Limit = ", ErrorDescription(GetLastError()));
                           }
                        }
                        if (f0_8() < 1) {
                           if (f0_28(OP_SELLLIMIT, g_lots_1908, gd_1620, 0, 0, "HiLow Sell Limit", MagicNumber) < 0) {
                              gd_1620 += gd_2300;
                              Print("Error HiLow Sell Limit = ", ErrorDescription(GetLastError()));
                           }
                        }
                        for (g_pos_736 = 0; g_pos_736 < OrdersTotal(); g_pos_736++) {
                           if (OrderSelect(g_pos_736, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol()) {
                              if (OrderType() == OP_BUYLIMIT && OrderMagicNumber() != g_magic_1704) g_order_open_price_1644 = OrderOpenPrice();
                              if (OrderType() == OP_SELLLIMIT && OrderMagicNumber() != g_magic_1704) g_order_open_price_1652 = OrderOpenPrice();
                           }
                        }
                     }
                  }
                  if (f0_29() + f0_17() > 0) {
                     if (f0_11() > 0 || f0_8() > 0) f0_21();
                     gi_664 = FALSE;
                     gi_660 = TRUE;
                  }
               }
            }
            if (gi_316 == TRUE) {
               gi_664 = FALSE;
               gi_660 = TRUE;
            }
         }
         if (Straddle == TRUE) {
            if (f0_29() + f0_17() <= 0) {
               if (f0_11() < 1 || f0_8() < 1) {
                  gd_896 = NormalizeDouble(Ask + StraddleRange * gd_2300, gi_2504);
                  gd_904 = NormalizeDouble(Bid - StraddleRange * gd_2300 - gd_2284, gi_2504);
                  if (f0_11() == 0) {
                     if (StraddleBuyPrice > 0.0) {
                        if (StraddleRange > 0) {
                           if (StraddleBuyPrice >= gd_896) {
                              gd_912 = StraddleBuyPrice;
                              if (f0_28(OP_BUYSTOP, g_lots_1908, gd_912, 0, 0, "Straddle Buy Stop", MagicNumber) == 0) gd_896 += gd_2300;
                           } else {
                              gd_912 = gd_896;
                              if (f0_28(OP_BUYSTOP, g_lots_1908, gd_912, 0, 0, "Straddle Buy Stop", MagicNumber) == 0) gd_896 += gd_2300;
                           }
                        }
                        if (StraddleRange == 0) {
                           gd_912 = StraddleBuyPrice;
                           if (f0_28(OP_BUYSTOP, g_lots_1908, gd_912, 0, 0, "Straddle Buy Stop", MagicNumber) == 0) gd_896 += gd_2300;
                        }
                     }
                     if (StraddleBuyPrice == 0.0) {
                        if (StraddleRange > 0) {
                           gd_912 = gd_896;
                           if (f0_28(OP_BUYSTOP, g_lots_1908, gd_912, 0, 0, "Straddle Buy Stop", MagicNumber) == 0) gd_896 += gd_2300;
                        }
                        if (StraddleRange == 0) {
                           if (gd_896 == 0.0) gd_896 = NormalizeDouble(Ask, gi_2504);
                           gd_912 = gd_896;
                           if (f0_28(OP_BUYSTOP, g_lots_1908, gd_912, 0, 0, "Straddle Buy Stop", MagicNumber) == 0) gd_896 += gd_2300;
                        }
                     }
                  }
                  if (f0_8() == 0) {
                     if (StraddleSellPrice > 0.0) {
                        if (StraddleRange > 0) {
                           if (StraddleSellPrice <= gd_904) {
                              gd_920 = StraddleSellPrice;
                              if (f0_28(OP_SELLSTOP, g_lots_1908, gd_920, 0, 0, "Straddle Sell Stop", MagicNumber) == 0) gd_904 -= gd_2300;
                           } else {
                              gd_920 = gd_904;
                              if (f0_28(OP_SELLSTOP, g_lots_1908, gd_920, 0, 0, "Straddle Sell Stop", MagicNumber) == 0) gd_904 -= gd_2300;
                           }
                        }
                        if (StraddleRange == 0) {
                           gd_920 = StraddleSellPrice;
                           if (f0_28(OP_SELLSTOP, g_lots_1908, gd_920, 0, 0, "Straddle Sell Stop", MagicNumber) == 0) gd_904 -= gd_2300;
                        }
                     }
                     if (StraddleSellPrice == 0.0) {
                        if (StraddleRange > 0) {
                           gd_920 = gd_904;
                           if (f0_28(OP_SELLSTOP, g_lots_1908, gd_920, 0, 0, "Straddle Sell Stop", MagicNumber) == 0) gd_904 -= gd_2300;
                        }
                        if (StraddleRange == 0) {
                           if (gd_904 == 0.0) gd_904 = NormalizeDouble(Bid, gi_2504);
                           gd_920 = gd_904;
                           if (f0_28(OP_SELLSTOP, g_lots_1908, gd_920, 0, 0, "Straddle Sell Stop", MagicNumber) == 0) gd_904 -= gd_2300;
                        }
                     }
                  }
               }
               for (g_pos_736 = 0; g_pos_736 < OrdersTotal(); g_pos_736++) {
                  if (OrderSelect(g_pos_736, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol()) {
                     if (OrderType() == OP_BUYSTOP && OrderMagicNumber() != g_magic_1704) {
                        g_order_open_price_1460 = OrderOpenPrice();
                        if (StraddleTakeProfit <= 0) gd_1428 = 0;
                        if (StraddleTakeProfit > 0) gd_1428 = gd_912 + StraddleTakeProfit * gd_2300;
                        if (StraddleStopLoss <= 0) gd_1436 = 0;
                        if (StraddleStopLoss > 0) gd_1436 = gd_912 - StraddleStopLoss * gd_2300;
                        if (g_price_1476 <= 0.0) g_price_1476 = gd_1428;
                        if (g_price_1484 <= 0.0) g_price_1484 = gd_1436;
                        if (!f0_5(OrderTakeProfit(), g_price_1476))
                           if (OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), g_price_1476, 0, CLR_NONE) == FALSE) g_price_1476 += gd_2300;
                        if (!f0_5(OrderStopLoss(), g_price_1484))
                           if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_1484, g_price_1476, 0, CLR_NONE) == FALSE) g_price_1484 -= gd_2300;
                     }
                     if (OrderType() == OP_SELLSTOP && OrderMagicNumber() != g_magic_1704) {
                        g_order_open_price_1468 = OrderOpenPrice();
                        if (StraddleTakeProfit <= 0) gd_1444 = 0;
                        if (StraddleTakeProfit > 0) gd_1444 = g_order_open_price_1468 - StraddleTakeProfit * gd_2300;
                        if (StraddleStopLoss <= 0) gd_1452 = 0;
                        if (StraddleStopLoss > 0) gd_1452 = g_order_open_price_1468 + StraddleStopLoss * gd_2300;
                        if (g_price_1492 <= 0.0) g_price_1492 = gd_1444;
                        if (g_price_1500 <= 0.0) g_price_1500 = gd_1452;
                        if (!f0_5(OrderTakeProfit(), g_price_1492))
                           if (OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), g_price_1492, 0, CLR_NONE) == FALSE) g_price_1492 -= gd_2300;
                        if (!f0_5(OrderStopLoss(), g_price_1500))
                           if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_1500, g_price_1492, 0, CLR_NONE) == FALSE) g_price_1500 += gd_2300;
                     }
                  }
               }
            }
            if (f0_29() + f0_17() > 0) {
               if (f0_11() > 0 || f0_8() > 0) f0_21();
               gi_664 = FALSE;
               Straddle = FALSE;
               gi_660 = TRUE;
            }
         }
      }
      if (gi_316 == FALSE) {
         if (f0_13() + f0_22() > 0.0) {
            if (f0_13() == f0_22()) {
               gi_660 = FALSE;
               for (g_pos_736 = 0; g_pos_736 < OrdersTotal(); g_pos_736++) {
                  if (OrderMagicNumber() != g_magic_1704) {
                     if (OrderSelect(g_pos_736, SELECT_BY_POS, MODE_TRADES)) {
                        if (OrderType() == OP_BUY && OrderSymbol() == Symbol()) {
                           g_order_open_price_1868 = OrderOpenPrice();
                           if (NormalizeDouble(Bid, gi_2504) - g_order_open_price_1868 >= CloseWhileHedgingProfit * gd_2300) {
                              RefreshRates();
                              if (OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Bid, gi_2504), 3, CLR_NONE) > 0) Print("Buy Hedging Position Eliminated");
                              else Print("Error Closing Buy Hedging = ", ErrorDescription(GetLastError()));
                           }
                        }
                        if (OrderType() == OP_SELL && OrderSymbol() == Symbol()) {
                           g_order_open_price_1876 = OrderOpenPrice();
                           if (g_order_open_price_1876 - NormalizeDouble(Ask, gi_2504) >= CloseWhileHedgingProfit * gd_2300) {
                              RefreshRates();
                              if (OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Ask, gi_2504), 3, CLR_NONE) > 0) {
                                 Print("Sell Hedging Position Eliminated");
                                 continue;
                              }
                              Print("Error Closing Sell Hedging = ", ErrorDescription(GetLastError()));
                           }
                        }
                     }
                  }
               }
            } else gi_660 = TRUE;
         }
      }
      if (gi_660 == TRUE) {
         f0_19();
         if (gi_2192 == TRUE) {
            if (gi_316 == FALSE && gi_272 == FALSE) {
               if (increase <= 0) increase = 0;
               if (increase > 0 && IncreaseEndLevel <= IncreaseStartLevel) IncreaseEndLevel = 0;
               if (increase > 0 && IncreaseStartLevel < 1) IncreaseStartLevel = 1;
            }
            if (Hedging == FALSE && Averaging == FALSE && gi_316 == FALSE && gi_272 == FALSE) {
               gi_744 = f0_29() + f0_17();
               for (g_pos_736 = 0; g_pos_736 < OrdersTotal(); g_pos_736++) {
                  if (OrderSelect(g_pos_736, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol()) {
                     if (OrderMagicNumber() != g_magic_1704) {
                        if (OrderType() == OP_BUY) {
                           gd_2204 += OrderLots();
                           g_order_open_price_2196 = OrderOpenPrice();
                        }
                        if (OrderType() == OP_SELL) g_order_open_price_2236 = OrderOpenPrice();
                        if (OrderType() == OP_BUYSTOP) gd_2212 += OrderLots();
                        if (OrderType() == OP_SELLSTOP) gd_2252 += OrderLots();
                     }
                  }
               }
               if (TakeProfit <= 0) {
                  g_price_2228 = 0;
                  g_price_2268 = 0;
               }
               if (TakeProfit > 0) {
                  g_price_2228 = g_order_open_price_2196 + TakeProfit * gd_2300;
                  g_price_2268 = g_order_open_price_2236 - TakeProfit * gd_2300;
               }
               if (StopLoss > 0) {
                  g_price_2220 = g_order_open_price_2196 - StopLoss * gd_2300;
                  g_price_2260 = g_order_open_price_2236 + StopLoss * gd_2300;
               }
            }
            if (gi_272 == TRUE) {
               for (g_pos_736 = 0; g_pos_736 < OrdersTotal(); g_pos_736++) {
                  if (OrderSelect(g_pos_736, SELECT_BY_POS, MODE_TRADES)) {
                     if (OrderMagicNumber() != g_magic_1704) {
                        if (OrderType() == OP_BUY) {
                           if (OrderSymbol() == gs_eurusd_300) gd_2100 += OrderLots();
                           if (OrderSymbol() == gs_usdchf_308) gd_2116 += OrderLots();
                        }
                        if (OrderType() == OP_SELL) {
                           if (OrderSymbol() == gs_eurusd_300) gd_2108 += OrderLots();
                           if (OrderSymbol() == gs_usdchf_308) gd_2124 += OrderLots();
                        }
                     }
                  }
               }
               gd_2132 = gd_2100 + gd_2116 + gd_2108 + gd_2124;
               gd_2140 = gd_2100 + gd_2116;
               gd_2148 = gd_2108 + gd_2124;
               if (gd_2132 <= 0.0) {
                  if (gs_buy_292 == "buy" || gs_buy_292 == "b") {
                     if (gd_2140 <= 0.0)
                        if (OrderSend(gs_eurusd_300, OP_BUY, g_lots_1908, MarketInfo(gs_eurusd_300, MODE_BID), 3, 0, 0, "Corr Buy", 0, 0, CLR_NONE) < 0) Print("Error Corr Buy = ", ErrorDescription(GetLastError()));
                  }
                  if (gs_buy_292 == "sell" || gs_buy_292 == "s") {
                     if (gd_2148 <= 0.0)
                        if (OrderSend(gs_eurusd_300, OP_SELL, g_lots_1908, MarketInfo(gs_eurusd_300, MODE_BID), 3, 0, 0, "Corr Sell", 0, 0, CLR_NONE) < 0) Print("Error Corr Sell = ", ErrorDescription(GetLastError()));
                  }
               }
               if (gd_2132 > 0.0) {
                  if (gd_2140 > 0.0) {
                     if (gd_2100 > gd_2116) {
                        g_lots_2156 = gd_2100 - gd_2116;
                        if (OrderSend(gs_usdchf_308, OP_BUY, g_lots_2156, MarketInfo(gs_usdchf_308, MODE_ASK), 3, 0, 0, "Corr Buy", 0, 0, CLR_NONE) < 0) Print("Error Corr Buy ", gs_usdchf_308, " = ", ErrorDescription(GetLastError()));
                     }
                     if (gd_2100 < gd_2116) {
                        g_lots_2156 = gd_2116 - gd_2100;
                        if (OrderSend(gs_eurusd_300, OP_BUY, g_lots_2156, MarketInfo(gs_eurusd_300, MODE_ASK), 3, 0, 0, "Corr Buy", 0, 0, CLR_NONE) < 0) Print("Error Corr Buy ", gs_eurusd_300, " = ", ErrorDescription(GetLastError()));
                     }
                  }
                  if (gd_2148 > 0.0) {
                     if (gd_2108 > gd_2124) {
                        g_lots_2164 = gd_2108 - gd_2124;
                        if (OrderSend(gs_usdchf_308, OP_SELL, g_lots_2164, MarketInfo(gs_usdchf_308, MODE_BID), 3, 0, 0, "Corr Sell", 0, 0, CLR_NONE) < 0) Print("Error Corr Sell ", gs_usdchf_308, " = ", ErrorDescription(GetLastError()));
                     }
                     if (gd_2108 < gd_2124) {
                        g_lots_2164 = gd_2124 - gd_2108;
                        if (OrderSend(gs_eurusd_300, OP_SELL, g_lots_2164, MarketInfo(gs_eurusd_300, MODE_BID), 3, 0, 0, "Corr Sell", 0, 0, CLR_NONE) < 0) Print("Error Corr Sell ", gs_eurusd_300, " = ", ErrorDescription(GetLastError()));
                     }
                  }
               }
               if (AccountProfit() >= gd_276) {
                  f0_2();
                  gs_1696 = "CorrProfitMoney";
               }
               if (AccountProfit() <= -gd_284) {
                  f0_2();
                  gs_1696 = "CorrLossMoney";
               }
            }
            if (gi_316 == TRUE) {
               gd_2204 = f0_13();
               gd_2244 = f0_22();
               if (gd_2052 > gd_2204) {
                  g_price_1956 = 0;
                  gd_1660 = 0;
                  gd_2052 = 0;
               } else gd_2052 = gd_2204;
               if (gd_2060 > gd_2244) {
                  g_price_1964 = 0;
                  gd_1668 = 0;
                  gd_2060 = 0;
               } else gd_2060 = gd_2244;
               if (gi_336 < gd_2308) {
                  gi_336 = gd_2308;
                  Print("MSRange is set to minimum Broker limit = ", DoubleToStr(gi_336, 0));
               }
               gd_1916 = NormalizeDouble(Ask + gi_336 * gd_2300 + gd_2284, gi_2504);
               gd_1924 = NormalizeDouble(Bid - gi_336 * gd_2300 - gd_2284, gi_2504);
               if (f0_4() + f0_23() <= 0.0) {
                  if (f0_9() < 1.0) {
                     if (f0_28(OP_BUYSTOP, LotSize, gd_1916, 0, 0, "MS Buy Stop", MagicNumber) < 0) {
                        Print("Error MS Buy Stop = ", ErrorDescription(GetLastError()));
                        gd_1916 += gd_2300;
                     }
                  }
                  if (f0_24() < 1.0) {
                     if (f0_28(OP_SELLSTOP, LotSize, gd_1924, 0, 0, "MS Sell Stop", MagicNumber) < 0) {
                        Print("Error MS Sell Stop = ", ErrorDescription(GetLastError()));
                        gd_1924 -= gd_2300;
                     }
                  }
               }
               if (f0_4() + f0_23() > 0.0) {
                  if (NormalizeDouble(f0_4(), 2) < NormalizeDouble(f0_23(), 2)) {
                     if (f0_9() < 1.0) {
                        gd_1932 = f0_23() - f0_4();
                        if (f0_28(OP_BUYSTOP, gd_1932, gd_1916, 0, 0, "MS Counter Buy Stop", MagicNumber) < 0) {
                           Print("Error MS Counter Buy Stop = ", ErrorDescription(GetLastError()));
                           gd_1916 += gd_2300;
                        }
                     }
                  }
                  if (NormalizeDouble(f0_4(), 2) > NormalizeDouble(f0_23(), 2)) {
                     if (f0_24() < 1.0) {
                        gd_1940 = f0_4() - f0_23();
                        if (f0_28(OP_SELLSTOP, gd_1940, gd_1924, 0, 0, "MS Counter Sell Stop", MagicNumber) < 0) {
                           Print("Error MS Counter Sell Stop = ", ErrorDescription(GetLastError()));
                           gd_1924 -= gd_2300;
                        }
                     }
                  }
               }
               if (gi_340 > 0)
                  if (gi_340 < gd_2308) gi_340 = gd_2308;
               if (gi_344 > 0)
                  if (gi_344 < gd_2308) gi_344 = gd_2308;
               if (gi_348 > 0 && gi_348 < gd_2308) {
                  gi_348 = gd_2308;
                  Print("MSTrailingStop is set to minimum Broker limit = ", DoubleToStr(gi_348, 0));
               }
               gd_1996 = AccountBalance() - g_str2dbl_1988 + AccountProfit();
               if (NormalizeDouble(gd_1996, 2) > NormalizeDouble(gi_356, 2)) {
                  gi_660 = FALSE;
                  if (OrdersTotal() > 0) {
                     f0_2();
                     g_price_1956 = 0;
                     gd_1660 = 0;
                     g_price_1964 = 0;
                     gd_1668 = 0;
                  }
                  FileDelete(g_name_1792);
                  g_error_728 = GetLastError();
                  if (g_error_728 != 0/* NO_ERROR */) {
                     Print("Error = ", g_error_728, " while deleting" + g_name_1792);
                     gi_656 = FALSE;
                     return (0);
                  }
                  if (OrdersTotal() <= 0) gi_660 = TRUE;
               }
               for (g_pos_736 = 0; g_pos_736 < OrdersTotal(); g_pos_736++) {
                  if (OrderSelect(g_pos_736, SELECT_BY_POS)) {
                     if (OrderSymbol() == Symbol() && OrderMagicNumber() != g_magic_1704) {
                        if (OrderType() == OP_BUY) {
                           gd_2068 += OrderLots();
                           if (gi_340 > 0) g_price_2228 = OrderOpenPrice() + gi_340 * gd_2300;
                           else g_price_2228 = 0;
                           if (gi_344 > 0) g_price_2220 = OrderOpenPrice() - gi_344 * gd_2300;
                           else g_price_2220 = 0;
                           if (gi_348 > 0) {
                              if (!f0_5(OrderTakeProfit(), g_price_2228))
                                 if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_2220, g_price_2228, 0, CLR_NONE) < FALSE) Print("Error Modifying MS Buy Open TP & SL = ", ErrorDescription(GetLastError()));
                              g_order_open_price_2004 = OrderOpenPrice();
                              g_order_stoploss_2020 = OrderStopLoss();
                              g_order_open_price_2196 = OrderOpenPrice();
                              if (NormalizeDouble(Bid, gi_2504) - g_order_open_price_2004 > gi_348 * gd_2300) {
                                 if (gi_352 > 0)
                                    if (gd_1660 < NormalizeDouble(Bid, gi_2504) - gi_352 * gd_2300) gd_1660 = NormalizeDouble(Bid - gi_352 * gd_2300, gi_2504);
                                 if (g_order_stoploss_2020 < NormalizeDouble(Bid, gi_2504) - gi_348 * gd_2300) {
                                    g_price_1972 = NormalizeDouble(Bid - gi_348 * gd_2300, gi_2504);
                                    if (!f0_5(OrderStopLoss(), g_price_1972))
                                       if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_1972, g_price_2228, 0, CLR_NONE) < FALSE) Print("Error Modifying MS Buy Open TS = ", ErrorDescription(GetLastError()));
                                 }
                              }
                              if (gd_1660 > 0.0) {
                                 if (NormalizeDouble(Bid, gi_2504) < gd_1660)
                                    if (OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 3, CLR_NONE) < 0) Print("Closing MS Buy Error ", ErrorDescription(GetLastError()));
                              }
                              if (OrderProfit() < 0.0) gd_1660 = 0;
                           } else {
                              if ((!f0_5(OrderTakeProfit(), g_price_2228)) || !f0_5(OrderStopLoss(), g_price_2220))
                                 if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_2220, g_price_2228, 0, CLR_NONE) < FALSE) Print("Error Modifying MS Buy Open TP & SL = ", ErrorDescription(GetLastError()));
                           }
                        }
                        if (OrderType() == OP_SELL) {
                           gd_2076 += OrderLots();
                           if (gi_340 > 0) g_price_2268 = OrderOpenPrice() - gi_340 * gd_2300;
                           else g_price_2268 = 0;
                           if (gi_344 > 0) g_price_2260 = OrderOpenPrice() + gi_344 * gd_2300;
                           else g_price_2260 = 0;
                           if (gi_348 > 0) {
                              if (!f0_5(OrderTakeProfit(), g_price_2268))
                                 if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_2260, g_price_2268, 0, CLR_NONE) < FALSE) Print("Error Modifying MS Sell Open TP & SL = ", ErrorDescription(GetLastError()));
                              g_order_open_price_2012 = OrderOpenPrice();
                              g_order_stoploss_2028 = OrderStopLoss();
                              g_order_open_price_2236 = OrderOpenPrice();
                              if (g_order_open_price_2012 - NormalizeDouble(Ask, gi_2504) > gi_348 * gd_2300) {
                                 if (gi_352 > 0)
                                    if (gd_1668 <= 0.0 || gd_1668 > NormalizeDouble(Ask, gi_2504) + gi_352 * gd_2300) gd_1668 = NormalizeDouble(Ask + gi_352 * gd_2300, gi_2504);
                                 if (g_order_stoploss_2028 == 0.0 || g_order_stoploss_2028 > NormalizeDouble(Ask, gi_2504) + gi_348 * gd_2300) {
                                    g_price_1980 = NormalizeDouble(Ask + gi_348 * gd_2300, gi_2504);
                                    if (!f0_5(OrderStopLoss(), g_price_1980))
                                       if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_1980, g_price_2268, 0, CLR_NONE) < FALSE) Print("Error Modifying MS Sell Open TS = ", ErrorDescription(GetLastError()));
                                 }
                              }
                              if (gd_1668 > 0.0) {
                                 if (NormalizeDouble(Ask, gi_2504) > gd_1668)
                                    if (OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 3, CLR_NONE) < 0) Print("Closing MS Sell Error ", ErrorDescription(GetLastError()));
                              }
                              if (OrderProfit() < 0.0) gd_1668 = 0;
                           } else {
                              if ((!f0_5(OrderTakeProfit(), g_price_2268)) || !f0_5(OrderStopLoss(), g_price_2260))
                                 if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_2260, g_price_2268, 0, CLR_NONE) < FALSE) Print("Error Modifying MS Sell Open TP & SL = ", ErrorDescription(GetLastError()));
                           }
                        }
                        if (OrderType() == OP_BUYSTOP) {
                           if (OrderOpenPrice() < NormalizeDouble(Ask, gi_2504)) OrderDelete(OrderTicket());
                           if (gi_340 > 0) g_price_2228 = OrderOpenPrice() + gi_340 * gd_2300;
                           else g_price_2228 = 0;
                           if (gi_344 > 0) g_price_2220 = OrderOpenPrice() - gi_344 * gd_2300;
                           else g_price_2220 = 0;
                           if (gi_324 == TRUE) {
                              if (gd_2076 > 0.0) f0_10();
                           } else f0_10();
                           if ((!f0_5(OrderTakeProfit(), g_price_2228)) || !f0_5(OrderStopLoss(), g_price_2220))
                              if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_2220, g_price_2228, 0, CLR_NONE) < FALSE) Print("Error Modifying MS Buy Stop TP & SL = ", ErrorDescription(GetLastError()));
                        }
                        if (OrderType() == OP_SELLSTOP) {
                           if (OrderOpenPrice() > NormalizeDouble(Bid, gi_2504)) OrderDelete(OrderTicket());
                           if (gi_340 > 0) g_price_2268 = OrderOpenPrice() - gi_340 * gd_2300;
                           else g_price_2268 = 0;
                           if (gi_344 > 0) g_price_2260 = OrderOpenPrice() + gi_344 * gd_2300;
                           else g_price_2260 = 0;
                           if (gi_324 == TRUE) {
                              if (gd_2068 > 0.0) f0_30();
                           } else f0_30();
                           if ((!f0_5(OrderTakeProfit(), g_price_2268)) || !f0_5(OrderStopLoss(), g_price_2260))
                              if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_2260, g_price_2268, 0, CLR_NONE) < FALSE) Print("Error Modifying MS Sell Stop TP & SL = ", ErrorDescription(GetLastError()));
                        }
                     }
                  }
               }
            }
            if (Hedging == TRUE) {
               if (f0_29() + f0_17() > 0) gi_744 = f0_29() + f0_17();
               for (g_pos_736 = 0; g_pos_736 < OrdersTotal(); g_pos_736++) {
                  if (OrderSelect(g_pos_736, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol()) {
                     if (OrderMagicNumber() != g_magic_1704) {
                        if (OrderType() == OP_BUY) {
                           gd_2204 += OrderLots();
                           g_order_open_price_2196 = OrderOpenPrice();
                           g_order_lots_768 = OrderLots();
                        }
                        if (OrderType() == OP_SELL) {
                           gd_2244 += OrderLots();
                           g_order_open_price_2236 = OrderOpenPrice();
                           g_order_lots_776 = OrderLots();
                        }
                        if (OrderType() == OP_BUYSTOP) gd_2212 += OrderLots();
                        if (OrderType() == OP_SELLSTOP) gd_2252 += OrderLots();
                     }
                  }
               }
               if (f0_13() > f0_22()) {
                  if (Multiplier == 0.0) gd_2276 = 2.0 * f0_13() - f0_22();
                  if (Multiplier == 1.0) gd_2276 = g_order_lots_768 + g_lots_1908;
                  if (Multiplier > 0.0 && Multiplier != 1.0) gd_2276 = g_order_lots_768 * Multiplier;
                  if (NormalizeDouble(gd_2276, 4) > NormalizeDouble(gd_2252, 4)) {
                     if (gd_1372 == 0.0) gd_1372 = gd_2204;
                     if (gd_1372 != gd_2204) {
                        gd_1372 = gd_2204;
                        f0_21();
                     }
                     if (increase > 0) {
                        if (gi_744 >= IncreaseStartLevel) {
                           if (IncreaseEndLevel == 0) gi_748 = gi_744 - IncreaseStartLevel + 1;
                           if (IncreaseEndLevel > 0 && gi_744 <= IncreaseEndLevel) gi_748 = gi_744 - IncreaseStartLevel + 1;
                           if (gd_960 > 0.0) gd_1548 = g_order_open_price_2196 - HedgeGap * gd_2300 - 2.0 * gd_960 - gi_748 * increase * gd_2300 - gd_2284;
                           else gd_1548 = g_order_open_price_2196 - HedgeGap * gd_2300 - gi_748 * increase * gd_2300 - gd_2284;
                        }
                        if (gi_744 < IncreaseStartLevel) {
                           if (gd_960 > 0.0) gd_1548 = g_order_open_price_2196 - HedgeGap * gd_2300 - 2.0 * gd_960 - gd_2284;
                           else gd_1548 = g_order_open_price_2196 - HedgeGap * gd_2300 - gd_2284;
                        }
                     } else {
                        if (gd_960 > 0.0) gd_1548 = g_order_open_price_2196 - HedgeGap * gd_2300 - 2.0 * gd_960 - gd_2284;
                        else gd_1548 = g_order_open_price_2196 - HedgeGap * gd_2300 - gd_2284;
                     }
                     gd_800 = NormalizeDouble(Bid, gi_2504);
                     if (gd_800 < gd_1548) {
                        gd_792 = gd_1548 - gd_800;
                        gd_1548 = gd_800;
                        Print("Sell Counter @ ", gd_1548);
                        if (f0_28(OP_SELL, gd_2276, gd_1548, 0, 0, "Sell at Market Price", MagicNumber) < 0) Print("Error Open Sell at Market Price = ", ErrorDescription(GetLastError()));
                        if (GapAdjustment == TRUE) gd_960 += gd_792;
                        else gd_960 = 0;
                     }
                     if (gd_800 >= gd_1548)
                        if (f0_28(OP_SELLSTOP, gd_2276, gd_1548, 0, 0, "Sell Stop", MagicNumber) < 0) Print("Error Open Sell Stop = ", ErrorDescription(GetLastError()));
                  }
                  if (NormalizeDouble(gd_2276, 4) < NormalizeDouble(gd_2252, 4)) f0_21();
               }
               if (f0_22() > f0_13()) {
                  if (Multiplier == 0.0) gd_2276 = 2.0 * f0_22() - f0_13();
                  if (Multiplier == 1.0) gd_2276 = g_order_lots_776 + g_lots_1908;
                  if (Multiplier > 0.0 && Multiplier != 1.0) gd_2276 = g_order_lots_776 * Multiplier;
                  if (NormalizeDouble(gd_2276, 4) > NormalizeDouble(gd_2212, 4)) {
                     if (gd_1380 == 0.0) gd_1380 = gd_2244;
                     if (gd_1380 != gd_2244) {
                        gd_1380 = gd_2244;
                        f0_21();
                     }
                     if (increase > 0) {
                        if (gi_744 >= IncreaseStartLevel) {
                           if (IncreaseEndLevel == 0) gi_748 = gi_744 - IncreaseStartLevel + 1;
                           if (IncreaseEndLevel > 0 && gi_744 <= IncreaseEndLevel) gi_748 = gi_744 - IncreaseStartLevel + 1;
                           if (gd_960 > 0.0) gd_1540 = g_order_open_price_2236 + HedgeGap * gd_2300 + 2.0 * gd_960 + gi_748 * increase * gd_2300 + gd_2284;
                           else gd_1540 = g_order_open_price_2236 + HedgeGap * gd_2300 + gi_748 * increase * gd_2300 + gd_2284;
                        }
                        if (gi_744 < IncreaseStartLevel) {
                           if (gd_960 > 0.0) gd_1540 = g_order_open_price_2236 + HedgeGap * gd_2300 + 2.0 * gd_960 + gd_2284;
                           else gd_1540 = g_order_open_price_2236 + HedgeGap * gd_2300 + gd_2284;
                        }
                     } else {
                        if (gd_960 > 0.0) gd_1540 = g_order_open_price_2236 + HedgeGap * gd_2300 + 2.0 * gd_960 + gd_2284;
                        else gd_1540 = g_order_open_price_2236 + HedgeGap * gd_2300 + gd_2284;
                     }
                     gd_808 = NormalizeDouble(Ask, gi_2504);
                     if (gd_808 > gd_1540) {
                        gd_784 = gd_808 - gd_1540;
                        gd_1540 = gd_808;
                        Print("Buy Counter @ ", gd_1540);
                        if (f0_28(OP_BUY, gd_2276, gd_1540, 0, 0, "Buy at Market Price", MagicNumber) < 0) Print("Error Open Buy at Market Price= ", ErrorDescription(GetLastError()));
                        if (GapAdjustment == TRUE) gd_960 += gd_784;
                        else gd_960 = 0;
                     }
                     if (gd_808 <= gd_1540)
                        if (f0_28(OP_BUYSTOP, gd_2276, gd_1540, 0, 0, "Buy Stop", MagicNumber) < 0) Print("Error Open Buy Stop= ", ErrorDescription(GetLastError()));
                  }
                  if (NormalizeDouble(gd_2276, 4) < NormalizeDouble(gd_2212, 4)) f0_21();
               }
               for (int pos_8 = 0; pos_8 < OrdersTotal(); pos_8++) {
                  if (OrderSelect(pos_8, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol()) {
                     if (OrderMagicNumber() != g_magic_1704) {
                        if (OrderType() == OP_BUYSTOP) {
                           gd_2212 += OrderLots();
                           g_order_open_price_1304 = OrderOpenPrice();
                           g_order_lots_1356 = OrderLots();
                        }
                        if (OrderType() == OP_SELLSTOP) {
                           gd_2252 += OrderLots();
                           g_order_open_price_1312 = OrderOpenPrice();
                           g_order_lots_1364 = OrderLots();
                        }
                     }
                  }
               }
               if (TakeProfit <= 0) {
                  g_price_2228 = 0;
                  g_price_2268 = 0;
                  g_price_2220 = 0;
                  g_price_2260 = 0;
               }
               if (TakeProfit > 0) {
                  if (GapAdjustment == FALSE) {
                     if (gd_784 > 0.0 || gd_792 > 0.0) {
                        if (g_price_2228 < f0_7() + TakeProfit * gd_2300) {
                           if (f0_7() == 0.0) g_price_2228 = g_order_open_price_2196 + TakeProfit * gd_2300;
                           else g_price_2228 = f0_7() + TakeProfit * gd_2300;
                        }
                        if (g_price_2268 == 0.0 || g_price_2268 > f0_14() - TakeProfit * gd_2300) {
                           if (f0_14() == 0.0) g_price_2268 = g_order_open_price_2236 - TakeProfit * gd_2300;
                           else g_price_2268 = f0_14() - TakeProfit * gd_2300;
                        }
                        if (StopLoss == 0) {
                           g_price_2220 = g_price_2268 - gd_2284;
                           g_price_2260 = g_price_2228 + gd_2284;
                        }
                        if (StopLoss > 0) {
                           g_price_2220 = g_order_open_price_2196 - StopLoss * gd_2300;
                           g_price_2260 = g_order_open_price_2236 + StopLoss * gd_2300;
                        }
                     } else {
                        if (StopLoss == 0) {
                           if (gd_2212 > gd_2252) {
                              g_price_2228 = g_order_open_price_1304 + TakeProfit * gd_2300;
                              g_price_2268 = g_order_open_price_2236 - TakeProfit * gd_2300;
                              g_price_2220 = g_price_2268 - gd_2284;
                              g_price_2260 = g_price_2228 + gd_2284;
                           }
                           if (gd_2252 > gd_2212) {
                              g_price_2228 = g_order_open_price_2196 + TakeProfit * gd_2300;
                              g_price_2268 = g_order_open_price_1312 - TakeProfit * gd_2300;
                              g_price_2220 = g_price_2268 - gd_2284;
                              g_price_2260 = g_price_2228 + gd_2284;
                           }
                        }
                        if (StopLoss > 0) {
                           if (gd_2212 > gd_2252) {
                              g_price_2228 = g_order_open_price_1304 + TakeProfit * gd_2300;
                              g_price_2268 = g_order_open_price_2236 - TakeProfit * gd_2300;
                              g_price_2220 = g_order_open_price_1304 - StopLoss * gd_2300;
                              g_price_2260 = g_order_open_price_2236 + StopLoss * gd_2300;
                           }
                           if (gd_2252 > gd_2212) {
                              g_price_2228 = g_order_open_price_2196 + TakeProfit * gd_2300;
                              g_price_2268 = g_order_open_price_1312 - TakeProfit * gd_2300;
                              g_price_2220 = g_order_open_price_2196 - StopLoss * gd_2300;
                              g_price_2260 = g_order_open_price_1312 + StopLoss * gd_2300;
                           }
                        }
                     }
                  }
                  if (GapAdjustment == TRUE) {
                     if (StopLoss == 0) {
                        if (gd_2212 > gd_2252) {
                           g_price_2228 = g_order_open_price_1304 + TakeProfit * gd_2300;
                           g_price_2268 = g_order_open_price_2236 - TakeProfit * gd_2300;
                           g_price_2220 = g_price_2268 - gd_2284;
                           g_price_2260 = g_price_2228 + gd_2284;
                        }
                        if (gd_2252 > gd_2212) {
                           g_price_2228 = g_order_open_price_2196 + TakeProfit * gd_2300;
                           g_price_2268 = g_order_open_price_1312 - TakeProfit * gd_2300;
                           g_price_2220 = g_price_2268 - gd_2284;
                           g_price_2260 = g_price_2228 + gd_2284;
                        }
                     }
                     if (StopLoss > 0) {
                        if (gd_2212 > gd_2252) {
                           g_price_2228 = g_order_open_price_1304 + TakeProfit * gd_2300;
                           g_price_2268 = g_order_open_price_2236 - TakeProfit * gd_2300;
                           g_price_2220 = g_order_open_price_1304 - StopLoss * gd_2300;
                           g_price_2260 = g_order_open_price_2236 + StopLoss * gd_2300;
                        }
                        if (gd_2252 > gd_2212) {
                           g_price_2228 = g_order_open_price_2196 + TakeProfit * gd_2300;
                           g_price_2268 = g_order_open_price_1312 - TakeProfit * gd_2300;
                           g_price_2220 = g_order_open_price_2196 - StopLoss * gd_2300;
                           g_price_2260 = g_order_open_price_1312 + StopLoss * gd_2300;
                        }
                     }
                  }
               }
               if (OrderMagicNumber() != g_magic_1704) {
                  for (g_pos_736 = 0; g_pos_736 < OrdersTotal(); g_pos_736++) {
                     if (OrderSelect(g_pos_736, SELECT_BY_POS)) {
                        if (OrderSymbol() == Symbol() && OrderMagicNumber() != g_magic_1704) {
                           if (OrderType() == OP_BUY) {
                              if ((!f0_5(OrderTakeProfit(), g_price_2228)) || !f0_5(OrderStopLoss(), g_price_2220)) {
                                 if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_2220, g_price_2228, 0, CLR_NONE)) {
                                 }
                              }
                           }
                           if (OrderType() == OP_SELL) {
                              if ((!f0_5(OrderTakeProfit(), g_price_2268)) || !f0_5(OrderStopLoss(), g_price_2260)) {
                                 if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_2260, g_price_2268, 0, CLR_NONE)) {
                                 }
                              }
                           }
                           if (OrderType() == OP_BUYSTOP)
                              if ((!f0_5(OrderTakeProfit(), g_price_2228)) || !f0_5(OrderStopLoss(), g_price_2220)) OrderModify(OrderTicket(), OrderOpenPrice(), g_price_2220, g_price_2228, 0, CLR_NONE);
                           if (OrderType() == OP_SELLSTOP)
                              if ((!f0_5(OrderTakeProfit(), g_price_2268)) || !f0_5(OrderStopLoss(), g_price_2260)) OrderModify(OrderTicket(), OrderOpenPrice(), g_price_2260, g_price_2268, 0, CLR_NONE);
                        }
                     }
                  }
               }
            }
            if (Averaging == TRUE) {
               if (f0_13() > f0_22()) gi_1812 = f0_29();
               if (f0_13() < f0_22()) gi_1816 = f0_17();
               for (g_pos_736 = 0; g_pos_736 < OrdersTotal(); g_pos_736++) {
                  if (OrderSelect(g_pos_736, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol()) {
                     if (OrderMagicNumber() != g_magic_1704) {
                        if (OrderType() == OP_BUY) {
                           gd_2204 += OrderLots();
                           g_order_open_price_2196 = OrderOpenPrice();
                           g_order_lots_768 = OrderLots();
                        }
                        if (OrderType() == OP_SELL) {
                           gd_2244 += OrderLots();
                           g_order_open_price_2236 = OrderOpenPrice();
                           g_order_lots_776 = OrderLots();
                        }
                        if (OrderType() == OP_BUYLIMIT) {
                           gd_2212 += OrderLots();
                           g_order_lots_1356 = OrderLots();
                        }
                        if (OrderType() == OP_SELLLIMIT) {
                           gd_2252 += OrderLots();
                           g_order_lots_1364 = OrderLots();
                        }
                     }
                  }
               }
               if (MaxLotStop > 0.0 && MaxLotStop > MarketInfo(Symbol(), MODE_MINLOT)) {
                  if (NormalizeDouble(g_order_lots_768, 4) >= NormalizeDouble(MaxLotStop, 4) || NormalizeDouble(g_order_lots_1356, 4) >= NormalizeDouble(MaxLotStop, 4)) gi_688 = TRUE;
                  else gi_688 = FALSE;
                  if (NormalizeDouble(g_order_lots_776, 4) >= NormalizeDouble(MaxLotStop, 4) || NormalizeDouble(g_order_lots_1364, 4) >= NormalizeDouble(MaxLotStop, 4)) gi_692 = TRUE;
                  else gi_692 = FALSE;
               }
               if (gi_688 == FALSE) {
                  if (f0_13() > f0_22()) {
                     if (StartFromHiLow == TRUE && HiLowIndicatorLevel > 0) {
                        gd_1580 = g_order_open_price_2196 - HiLowIndicatorLevel * gd_2300;
                        if (NormalizeDouble(Bid, gi_2504) <= gd_1580) gd_1596 = 1;
                        if (gd_1596 == 1.0) {
                           if (NormalizeDouble(Bid, gi_2504) >= g_order_open_price_2196) {
                              f0_2();
                              gs_1696 = "HiLow Indicator Buy";
                              gd_1596 = 0;
                           }
                        }
                     }
                     if (AveragingMultiplier == 0.0) gd_2276 = g_lots_1908;
                     if (AveragingMultiplier == 1.0) gd_2276 = g_order_lots_768 + g_lots_1908;
                     if (AveragingMultiplier > 0.0 && AveragingMultiplier != 1.0) gd_2276 = g_order_lots_768 * AveragingMultiplier;
                     if (MaxLotStop > 0.0 && MaxLotStop > MarketInfo(Symbol(), MODE_MINLOT))
                        if (NormalizeDouble(MaxLotStop, 4) < NormalizeDouble(gd_2276, 4)) gd_2276 = MaxLotStop;
                     if (NormalizeDouble(gd_2276, 4) > NormalizeDouble(gd_2212, 4)) {
                        if (gd_1372 == 0.0) gd_1372 = gd_2204;
                        if (gd_1372 != gd_2204) {
                           gd_1372 = gd_2204;
                           f0_21();
                        }
                        if (increase > 0) {
                           if (gi_1812 >= IncreaseStartLevel) {
                              if (IncreaseEndLevel == 0) gi_748 = gi_1812 - IncreaseStartLevel + 1;
                              if (IncreaseEndLevel > 0 && gi_1812 <= IncreaseEndLevel) gi_748 = gi_1812 - IncreaseStartLevel + 1;
                              if (gd_960 > 0.0) gd_1540 = g_order_open_price_2196 - AveragingHedgeGap * gd_2300 - 2.0 * gd_960 - gi_748 * increase * gd_2300 - gd_2284;
                              else gd_1540 = g_order_open_price_2196 - AveragingHedgeGap * gd_2300 - gi_748 * increase * gd_2300 - gd_2284;
                           }
                           if (gi_1812 < IncreaseStartLevel) {
                              if (gd_960 > 0.0) gd_1540 = g_order_open_price_2196 - AveragingHedgeGap * gd_2300 - 2.0 * gd_960 - gd_2284;
                              else gd_1540 = g_order_open_price_2196 - AveragingHedgeGap * gd_2300 - gd_2284;
                           }
                        } else {
                           if (gd_960 > 0.0) gd_1540 = g_order_open_price_2196 - AveragingHedgeGap * gd_2300 - 2.0 * gd_960 - gd_2284;
                           else gd_1540 = g_order_open_price_2196 - AveragingHedgeGap * gd_2300 - gd_2284;
                        }
                        gd_808 = NormalizeDouble(Ask, gi_2504);
                        if (gd_808 < gd_1540) {
                           gd_784 = gd_1540 - gd_808;
                           gd_1540 = gd_808;
                           Print("Average Buy Counter @ ", gd_1540);
                           if (f0_28(OP_BUY, gd_2276, gd_1540, 0, 0, "Average Buy at Market Price", MagicNumber) < 0) Print("Error Open Buy Average at Market Price = ", ErrorDescription(GetLastError()));
                           if (GapAdjustment == TRUE) gd_960 += gd_784;
                           else gd_960 = 0;
                        }
                        if (gd_808 >= gd_1540)
                           if (f0_28(OP_BUYLIMIT, gd_2276, gd_1540, 0, 0, "Buy Limit", MagicNumber) < 0) Print("Error Open Buy Limit = ", ErrorDescription(GetLastError()));
                     }
                     if (NormalizeDouble(gd_2276, 4) < NormalizeDouble(gd_2212, 4)) f0_21();
                  }
               }
               if (gi_692 == FALSE) {
                  if (f0_22() > f0_13()) {
                     if (StartFromHiLow == TRUE && HiLowIndicatorLevel > 0) {
                        gd_1588 = g_order_open_price_2236 + HiLowIndicatorLevel * gd_2300;
                        if (NormalizeDouble(Ask, gi_2504) >= gd_1588) gd_1604 = 1;
                        if (gd_1604 == 1.0) {
                           if (NormalizeDouble(Bid, gi_2504) <= g_order_open_price_2236) {
                              f0_2();
                              gs_1696 = "HiLow Indicator Sell";
                              gd_1604 = 0;
                           }
                        }
                     }
                     if (AveragingMultiplier == 0.0) gd_2276 = g_lots_1908;
                     if (AveragingMultiplier == 1.0) gd_2276 = g_order_lots_776 + g_lots_1908;
                     if (AveragingMultiplier > 0.0 && AveragingMultiplier != 1.0) gd_2276 = g_order_lots_776 * AveragingMultiplier;
                     if (MaxLotStop > 0.0 && MaxLotStop > MarketInfo(Symbol(), MODE_MINLOT))
                        if (NormalizeDouble(MaxLotStop, 4) < NormalizeDouble(gd_2276, 4)) gd_2276 = MaxLotStop;
                     if (NormalizeDouble(gd_2276, 4) > NormalizeDouble(gd_2252, 4)) {
                        if (gd_1380 == 0.0) gd_1380 = gd_2244;
                        if (gd_1380 != gd_2244) {
                           gd_1380 = gd_2244;
                           f0_21();
                        }
                        if (increase > 0) {
                           if (gi_1816 >= IncreaseStartLevel) {
                              if (IncreaseEndLevel == 0) gi_748 = gi_1816 - IncreaseStartLevel + 1;
                              if (IncreaseEndLevel > 0 && gi_1816 <= IncreaseEndLevel) gi_748 = gi_1816 - IncreaseStartLevel + 1;
                              if (gd_960 > 0.0) gd_1548 = g_order_open_price_2236 + AveragingHedgeGap * gd_2300 + 2.0 * gd_960 + gi_748 * increase * gd_2300 + gd_2284;
                              else gd_1548 = g_order_open_price_2236 + AveragingHedgeGap * gd_2300 + gi_748 * increase * gd_2300 + gd_2284;
                           }
                           if (gi_1816 < IncreaseStartLevel) {
                              if (gd_960 > 0.0) gd_1548 = g_order_open_price_2236 + AveragingHedgeGap * gd_2300 + 2.0 * gd_960 + gd_2284;
                              else gd_1548 = g_order_open_price_2236 + AveragingHedgeGap * gd_2300 + gd_2284;
                           }
                        } else {
                           if (gd_960 > 0.0) gd_1548 = g_order_open_price_2236 + AveragingHedgeGap * gd_2300 + 2.0 * gd_960 + gd_2284;
                           else gd_1548 = g_order_open_price_2236 + AveragingHedgeGap * gd_2300 + gd_2284;
                        }
                        gd_800 = NormalizeDouble(Bid, gi_2504);
                        if (gd_800 >= gd_1548) {
                           gd_792 = gd_800 - gd_1548;
                           gd_1548 = gd_800;
                           Print("Average Sell Counter @ ", gd_1548);
                           if (f0_28(OP_SELL, gd_2276, gd_1548, 0, 0, "Sell Average at Market Price", MagicNumber) < 0) Print("Error Open Sell Average at Market Price= ", ErrorDescription(GetLastError()));
                           if (GapAdjustment == TRUE) gd_960 += gd_792;
                           else gd_960 = 0;
                        }
                        if (gd_800 < gd_1548)
                           if (f0_28(OP_SELLLIMIT, gd_2276, gd_1548, 0, 0, "Sell Limit", MagicNumber) < 0) Print("Error Open Sell Limit= ", ErrorDescription(GetLastError()));
                     }
                     if (NormalizeDouble(gd_2276, 4) < NormalizeDouble(gd_2252, 4)) f0_21();
                  }
               }
               for (pos_8 = 0; pos_8 < OrdersTotal(); pos_8++) {
                  if (OrderSelect(pos_8, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol()) {
                     if (OrderMagicNumber() != g_magic_1704) {
                        if (OrderType() == OP_BUYLIMIT) {
                           gd_2212 += OrderLots();
                           g_order_open_price_1304 = OrderOpenPrice();
                           g_order_lots_1356 = OrderLots();
                        }
                        if (OrderType() == OP_SELLLIMIT) {
                           gd_2252 += OrderLots();
                           g_order_open_price_1312 = OrderOpenPrice();
                           g_order_lots_1364 = OrderLots();
                        }
                     }
                  }
               }
               if (AveragingTakeProfit <= 0) {
                  g_price_2228 = 0;
                  g_price_2268 = 0;
                  g_price_2220 = 0;
                  g_price_2260 = 0;
               }
               if (AveragingTakeProfit > 0) {
                  if (gd_2204 > gd_2244) {
                     if (gd_2212 > 0.0) {
                        if (g_order_open_price_1304 > f0_27()) {
                           if (g_price_2228 < g_order_open_price_1304 + AveragingTakeProfit * gd_2300) g_price_2228 = g_order_open_price_1304 + AveragingTakeProfit * gd_2300;
                        } else
                           if (g_price_2228 < f0_27() + AveragingTakeProfit * gd_2300) g_price_2228 = f0_27() + AveragingTakeProfit * gd_2300;
                     } else
                        if (g_price_2228 < f0_27() + AveragingTakeProfit * gd_2300) g_price_2228 = f0_27() + AveragingTakeProfit * gd_2300;
                  }
                  if (gd_2244 > gd_2204) {
                     if (gd_2252 > 0.0) {
                        if (g_order_open_price_1312 < f0_20()) {
                           if (g_price_2268 == 0.0 || g_price_2268 > g_order_open_price_1312 - AveragingTakeProfit * gd_2300) g_price_2268 = g_order_open_price_1312 - AveragingTakeProfit * gd_2300;
                        } else
                           if (g_price_2268 == 0.0 || g_price_2268 > f0_20() - AveragingTakeProfit * gd_2300) g_price_2268 = f0_20() - AveragingTakeProfit * gd_2300;
                     } else
                        if (g_price_2268 == 0.0 || g_price_2268 > f0_20() - AveragingTakeProfit * gd_2300) g_price_2268 = f0_20() - AveragingTakeProfit * gd_2300;
                  }
               } else {
                  g_price_2228 = 0;
                  g_price_2268 = 0;
               }
               if (AveragingStopLoss > 0) {
                  if (gd_2204 > gd_2244) {
                     if (gd_2212 > 0.0) {
                        if (g_order_open_price_1304 > f0_27()) {
                           if (g_price_2220 == 0.0 || g_price_2220 > f0_27() - AveragingStopLoss * gd_2300) g_price_2220 = f0_27() - AveragingStopLoss * gd_2300;
                        } else
                           if (g_price_2220 == 0.0 || g_price_2220 > g_order_open_price_1304 - AveragingStopLoss * gd_2300) g_price_2220 = g_order_open_price_1304 - AveragingStopLoss * gd_2300;
                     } else
                        if (g_price_2220 == 0.0 || g_price_2220 > f0_27() - AveragingStopLoss * gd_2300) g_price_2220 = f0_27() - AveragingStopLoss * gd_2300;
                  }
                  if (gd_2244 > gd_2204) {
                     if (gd_2252 > 0.0) {
                        if (g_order_open_price_1312 < f0_20()) {
                           if (g_price_2260 < f0_20() + AveragingStopLoss * gd_2300) g_price_2260 = f0_20() + AveragingStopLoss * gd_2300;
                        } else
                           if (g_price_2260 < g_order_open_price_1312 + AveragingStopLoss * gd_2300) g_price_2260 = g_order_open_price_1312 + AveragingStopLoss * gd_2300;
                     } else
                        if (g_price_2260 < f0_20() + AveragingStopLoss * gd_2300) g_price_2260 = f0_20() + AveragingStopLoss * gd_2300;
                  }
               } else {
                  g_price_2220 = 0;
                  g_price_2260 = 0;
               }
               if (OrderMagicNumber() != g_magic_1704) {
                  for (g_pos_736 = 0; g_pos_736 < OrdersTotal(); g_pos_736++) {
                     if (OrderSelect(g_pos_736, SELECT_BY_POS)) {
                        if (OrderSymbol() == Symbol() && OrderMagicNumber() != g_magic_1704) {
                           if (OrderType() == OP_BUY) {
                              if ((!f0_5(OrderTakeProfit(), g_price_2228)) || !f0_5(OrderStopLoss(), g_price_2220)) {
                                 if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_2220, g_price_2228, 0, CLR_NONE)) {
                                 }
                              }
                           }
                           if (OrderType() == OP_SELL) {
                              if ((!f0_5(OrderTakeProfit(), g_price_2268)) || !f0_5(OrderStopLoss(), g_price_2260)) {
                                 if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_2260, g_price_2268, 0, CLR_NONE)) {
                                 }
                              }
                           }
                           if (OrderType() == OP_BUYLIMIT) {
                              if (f0_29() < 1 && OrderMagicNumber() != 5566) OrderDelete(OrderTicket());
                              if ((!f0_5(OrderTakeProfit(), g_price_2228)) || !f0_5(OrderStopLoss(), g_price_2220)) OrderModify(OrderTicket(), OrderOpenPrice(), g_price_2220, g_price_2228, 0, CLR_NONE);
                           }
                           if (OrderType() == OP_SELLLIMIT) {
                              if (f0_17() < 1 && OrderMagicNumber() != 5566) OrderDelete(OrderTicket());
                              if ((!f0_5(OrderTakeProfit(), g_price_2268)) || !f0_5(OrderStopLoss(), g_price_2260)) OrderModify(OrderTicket(), OrderOpenPrice(), g_price_2260, g_price_2268, 0, CLR_NONE);
                           }
                        }
                     }
                  }
               }
            }
            if (DisableTrailingStop == FALSE) {
               if (TrailingStop <= 0) {
                  TrailingStopStartLevel = 0;
                  TrailingStopEndLevel = 0;
               }
               if (TrailingStop > 0)
                  if (TrailingStopEndLevel <= TrailingStopStartLevel) TrailingStopEndLevel = 0;
               if (TrailingStop > 0)
                  if (TrailingStopStartLevel < 1) TrailingStopStartLevel = 1;
               if (TrailingStop_2 > 0)
                  if (TrailingStop_2_EndLevel <= TrailingStop_2_StartLevel) TrailingStop_2_EndLevel = 0;
               if (TrailingStop_2 > 0)
                  if (TrailingStop_2_StartLevel < 1) TrailingStop_2_StartLevel = 1;
               if (TrailingStop_3 > 0)
                  if (TrailingStop_3_EndLevel <= TrailingStop_3_StartLevel) TrailingStop_3_EndLevel = 0;
               if (TrailingStop_3 > 0)
                  if (TrailingStop_3_StartLevel < 1) TrailingStop_3_StartLevel = 1;
               if (TrailingStop_4 > 0)
                  if (TrailingStop_4_EndLevel <= TrailingStop_4_StartLevel) TrailingStop_4_EndLevel = 0;
               if (TrailingStop_4 > 0)
                  if (TrailingStop_4_StartLevel < 1) TrailingStop_4_StartLevel = 1;
               if (f0_13() > f0_22()) {
                  if (Averaging == TRUE) gi_744 = gi_1812;
                  for (g_pos_736 = 0; g_pos_736 < OrdersTotal(); g_pos_736++) {
                     if (OrderSelect(g_pos_736, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol()) {
                        if (OrderType() == OP_BUY && OrderMagicNumber() != g_magic_1704) {
                           if (TrailingStop > 0) {
                              if (gi_744 >= TrailingStopStartLevel) {
                                 if (TrailingStopEndLevel == 0 || gi_744 < TrailingStopEndLevel) {
                                    if (AccountProfit() >= 0.0) {
                                       if (gd_968 == 0.0 || NormalizeDouble(Bid, gi_2504) < gd_968) gd_968 = NormalizeDouble(Bid, gi_2504);
                                       if (NormalizeDouble(Bid, gi_2504) - gd_968 > TrailingStop * gd_2300) {
                                          gd_848 = NormalizeDouble(Bid - TrailingStop * gd_2300, gi_2504);
                                          if (gd_928 < gd_848) gd_928 = gd_848;
                                       }
                                       if (gd_928 > 0.0) {
                                          if (NormalizeDouble(Bid, gi_2504) > gd_816) {
                                             gd_816 = NormalizeDouble(Bid, gi_2504);
                                             if (Rebound > 0) gd_832 = gd_816 - Rebound * gd_2300;
                                          }
                                          if (NormalizeDouble(Bid, gi_2504) < gd_928 || NormalizeDouble(Bid, gi_2504) < gd_832) {
                                             f0_2();
                                             gs_1696 = "Trailing Stop Buy";
                                          }
                                       }
                                    }
                                    if (AccountProfit() < 0.0) {
                                       gd_968 = 0;
                                       gd_928 = 0;
                                       gd_832 = 0;
                                       gd_816 = 0;
                                    }
                                 }
                              }
                           }
                        }
                        if (TrailingStop_2 > 0) {
                           if (gi_744 >= TrailingStop_2_StartLevel) {
                              if (TrailingStop_2_EndLevel == 0 || gi_744 < TrailingStop_2_EndLevel) {
                                 if (AccountProfit() >= 0.0) {
                                    if (gd_984 == 0.0 || NormalizeDouble(Bid, gi_2504) < gd_984) gd_984 = NormalizeDouble(Bid, gi_2504);
                                    if (NormalizeDouble(Bid, gi_2504) - gd_984 > TrailingStop_2 * gd_2300) {
                                       gd_1000 = NormalizeDouble(Bid - TrailingStop_2 * gd_2300, gi_2504);
                                       if (gd_992 < gd_1000) gd_992 = gd_1000;
                                    }
                                    if (gd_992 > 0.0) {
                                       if (NormalizeDouble(Bid, gi_2504) > gd_1008) {
                                          gd_1008 = NormalizeDouble(Bid, gi_2504);
                                          if (Rebound_2 > 0) gd_1016 = gd_1008 - Rebound_2 * gd_2300;
                                       }
                                       if (NormalizeDouble(Bid, gi_2504) < gd_992 || NormalizeDouble(Bid, gi_2504) < gd_1016) {
                                          f0_2();
                                          gs_1696 = "Trailing Stop Buy 2";
                                       }
                                    }
                                 }
                                 if (AccountProfit() < 0.0) {
                                    gd_984 = 0;
                                    gd_992 = 0;
                                    gd_1016 = 0;
                                    gd_1008 = 0;
                                 }
                              }
                           }
                        }
                        if (TrailingStop_3 > 0) {
                           if (gi_744 >= TrailingStop_3_StartLevel) {
                              if (TrailingStop_3_EndLevel == 0 || gi_744 < TrailingStop_3_EndLevel) {
                                 if (AccountProfit() >= 0.0) {
                                    if (gd_1064 == 0.0 || NormalizeDouble(Bid, gi_2504) < gd_1064) gd_1064 = NormalizeDouble(Bid, gi_2504);
                                    if (NormalizeDouble(Bid, gi_2504) - gd_1064 > TrailingStop_3 * gd_2300) {
                                       gd_1080 = NormalizeDouble(Bid - TrailingStop_3 * gd_2300, gi_2504);
                                       if (gd_1072 < gd_1080) gd_1072 = gd_1080;
                                    }
                                    if (gd_1072 > 0.0) {
                                       if (NormalizeDouble(Bid, gi_2504) > gd_1088) {
                                          gd_1088 = NormalizeDouble(Bid, gi_2504);
                                          if (Rebound_3 > 0) gd_1096 = gd_1088 - Rebound_3 * gd_2300;
                                       }
                                       if (NormalizeDouble(Bid, gi_2504) < gd_1072 || NormalizeDouble(Bid, gi_2504) < gd_1096) {
                                          f0_2();
                                          gs_1696 = "Trailing Stop Buy 3";
                                       }
                                    }
                                 }
                                 if (AccountProfit() < 0.0) {
                                    gd_1064 = 0;
                                    gd_1072 = 0;
                                    gd_1096 = 0;
                                    gd_1088 = 0;
                                 }
                              }
                           }
                        }
                        if (TrailingStop_4 > 0) {
                           if (gi_744 >= TrailingStop_4_StartLevel) {
                              if (TrailingStop_4_EndLevel == 0 || gi_744 < TrailingStop_4_EndLevel) {
                                 if (AccountProfit() >= 0.0) {
                                    if (gd_1144 == 0.0 || NormalizeDouble(Bid, gi_2504) < gd_1144) gd_1144 = NormalizeDouble(Bid, gi_2504);
                                    if (NormalizeDouble(Bid, gi_2504) - gd_1144 > TrailingStop_4 * gd_2300) {
                                       gd_1160 = NormalizeDouble(Bid - TrailingStop_4 * gd_2300, gi_2504);
                                       if (gd_1152 < gd_1160) gd_1152 = gd_1160;
                                    }
                                    if (gd_1152 > 0.0) {
                                       if (NormalizeDouble(Bid, gi_2504) > gd_1168) {
                                          gd_1168 = NormalizeDouble(Bid, gi_2504);
                                          if (Rebound_4 > 0) gd_1176 = gd_1168 - Rebound_4 * gd_2300;
                                       }
                                       if (NormalizeDouble(Bid, gi_2504) < gd_1152 || NormalizeDouble(Bid, gi_2504) < gd_1176) {
                                          f0_2();
                                          gs_1696 = "Trailing Stop Buy 4";
                                       }
                                    }
                                 }
                                 if (AccountProfit() < 0.0) {
                                    gd_1144 = 0;
                                    gd_1152 = 0;
                                    gd_1176 = 0;
                                    gd_1168 = 0;
                                 }
                              }
                           }
                        }
                     }
                  }
               }
               if (f0_22() > f0_13()) {
                  if (Averaging == TRUE) gi_744 = gi_1816;
                  for (g_pos_736 = 0; g_pos_736 < OrdersTotal(); g_pos_736++) {
                     if (OrderSelect(g_pos_736, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol()) {
                        if (OrderType() == OP_SELL && OrderMagicNumber() != g_magic_1704) {
                           if (TrailingStop > 0) {
                              if (gi_744 >= TrailingStopStartLevel) {
                                 if (TrailingStopEndLevel == 0 || gi_744 < TrailingStopEndLevel) {
                                    if (AccountProfit() >= 0.0) {
                                       if (gd_976 == 0.0 || NormalizeDouble(Ask, gi_2504) > gd_976) gd_976 = NormalizeDouble(Ask, gi_2504);
                                       if (gd_976 - NormalizeDouble(Ask, gi_2504) > TrailingStop * gd_2300) {
                                          gd_856 = NormalizeDouble(Ask + TrailingStop * gd_2300, gi_2504);
                                          if (gd_936 == 0.0 || gd_936 > gd_856) gd_936 = gd_856;
                                       }
                                       if (gd_936 > 0.0) {
                                          if (gd_824 == 0.0 || NormalizeDouble(Ask, gi_2504) < gd_824) {
                                             gd_824 = NormalizeDouble(Ask, gi_2504);
                                             if (Rebound > 0) gd_840 = gd_824 + Rebound * gd_2300;
                                          }
                                          if (NormalizeDouble(Ask, gi_2504) > gd_936 || NormalizeDouble(Ask, gi_2504) > gd_840) {
                                             f0_2();
                                             gs_1696 = "Trailing Stop Sell";
                                          }
                                       }
                                    }
                                    if (AccountProfit() < 0.0) {
                                       gd_976 = 0;
                                       gd_936 = 0;
                                       gd_840 = 0;
                                       gd_824 = 0;
                                    }
                                 }
                              }
                           }
                        }
                        if (TrailingStop_2 > 0) {
                           if (gi_744 >= TrailingStop_2_StartLevel) {
                              if (TrailingStop_2_EndLevel == 0 || gi_744 < TrailingStop_2_EndLevel) {
                                 if (AccountProfit() >= 0.0) {
                                    if (gd_1024 == 0.0 || NormalizeDouble(Ask, gi_2504) > gd_1024) gd_1024 = NormalizeDouble(Ask, gi_2504);
                                    if (gd_1024 - NormalizeDouble(Ask, gi_2504) > TrailingStop_2 * gd_2300) {
                                       gd_1040 = NormalizeDouble(Ask + TrailingStop_2 * gd_2300, gi_2504);
                                       if (gd_1032 == 0.0 || gd_1032 > gd_1040) gd_1032 = gd_1040;
                                    }
                                    if (gd_1032 > 0.0) {
                                       if (gd_1048 == 0.0 || NormalizeDouble(Ask, gi_2504) < gd_1048) {
                                          gd_1048 = NormalizeDouble(Ask, gi_2504);
                                          if (Rebound_2 > 0) gd_1056 = gd_1048 + Rebound_2 * gd_2300;
                                       }
                                       if (NormalizeDouble(Ask, gi_2504) > gd_1032 || NormalizeDouble(Ask, gi_2504) > gd_1056) {
                                          f0_2();
                                          gs_1696 = "Trailing Stop Sell 2";
                                       }
                                    }
                                 }
                                 if (AccountProfit() < 0.0) {
                                    gd_1024 = 0;
                                    gd_1032 = 0;
                                    gd_1056 = 0;
                                    gd_1048 = 0;
                                 }
                              }
                           }
                        }
                        if (TrailingStop_3 > 0) {
                           if (gi_744 >= TrailingStop_3_StartLevel) {
                              if (TrailingStop_3_EndLevel == 0 || gi_744 < TrailingStop_3_EndLevel) {
                                 if (AccountProfit() >= 0.0) {
                                    if (gd_1104 == 0.0 || NormalizeDouble(Ask, gi_2504) > gd_1104) gd_1104 = NormalizeDouble(Ask, gi_2504);
                                    if (gd_1104 - NormalizeDouble(Ask, gi_2504) > TrailingStop_3 * gd_2300) {
                                       gd_1120 = NormalizeDouble(Ask + TrailingStop_3 * gd_2300, gi_2504);
                                       if (gd_1112 == 0.0 || gd_1112 > gd_1120) gd_1112 = gd_1120;
                                    }
                                    if (gd_1112 > 0.0) {
                                       if (gd_1128 == 0.0 || NormalizeDouble(Ask, gi_2504) < gd_1128) {
                                          gd_1128 = NormalizeDouble(Ask, gi_2504);
                                          if (Rebound_3 > 0) gd_1136 = gd_1128 + Rebound_3 * gd_2300;
                                       }
                                       if (NormalizeDouble(Ask, gi_2504) > gd_1112 || NormalizeDouble(Ask, gi_2504) > gd_1136) {
                                          f0_2();
                                          gs_1696 = "Trailing Stop Sell 3";
                                       }
                                    }
                                 }
                                 if (AccountProfit() < 0.0) {
                                    gd_1104 = 0;
                                    gd_1112 = 0;
                                    gd_1136 = 0;
                                    gd_1128 = 0;
                                 }
                              }
                           }
                        }
                        if (TrailingStop_4 > 0) {
                           if (gi_744 >= TrailingStop_4_StartLevel) {
                              if (TrailingStop_4_EndLevel == 0 || gi_744 < TrailingStop_4_EndLevel) {
                                 if (AccountProfit() >= 0.0) {
                                    if (gd_1184 == 0.0 || NormalizeDouble(Ask, gi_2504) > gd_1184) gd_1184 = NormalizeDouble(Ask, gi_2504);
                                    if (gd_1184 - NormalizeDouble(Ask, gi_2504) > TrailingStop_4 * gd_2300) {
                                       gd_1200 = NormalizeDouble(Ask + TrailingStop_4 * gd_2300, gi_2504);
                                       if (gd_1192 == 0.0 || gd_1192 > gd_1200) gd_1192 = gd_1200;
                                    }
                                    if (gd_1192 > 0.0) {
                                       if (gd_1208 == 0.0 || NormalizeDouble(Ask, gi_2504) < gd_1208) {
                                          gd_1128 = NormalizeDouble(Ask, gi_2504);
                                          if (Rebound_4 > 0) gd_1216 = gd_1208 + Rebound_4 * gd_2300;
                                       }
                                       if (NormalizeDouble(Ask, gi_2504) > gd_1192 || NormalizeDouble(Ask, gi_2504) > gd_1216) {
                                          f0_2();
                                          gs_1696 = "Trailing Stop Sell 4";
                                       }
                                    }
                                 }
                                 if (AccountProfit() < 0.0) {
                                    gd_1184 = 0;
                                    gd_1192 = 0;
                                    gd_1216 = 0;
                                    gd_1208 = 0;
                                 }
                              }
                           }
                        }
                     }
                  }
               }
            }
            if (Doubler == TRUE) {
               if (DoublerEndLevel <= DoublerStartLevel) DoublerEndLevel = 0;
               if (DoublerStartLevel < 1) DoublerStartLevel = 1;
               if (DoublerMaxOrder < 0) DoublerMaxOrder = 0;
               if (gi_724 != gi_744) {
                  gi_724 = gi_744;
                  if (g_count_1336 > 0 || g_count_1340 > 0) {
                     g_count_1336 = 0;
                     g_count_1340 = 0;
                  }
               }
               if (f0_31() > f0_25()) {
                  if (Averaging == TRUE) gi_744 = gi_1812;
                  if (gi_744 >= DoublerStartLevel) {
                     if (DoublerEndLevel == 0 || gi_744 < DoublerEndLevel) {
                        if (DoublerMaxOrder == 0 || g_count_1336 < DoublerMaxOrder) {
                           if (AccountProfit() >= 0.0) {
                              if (f0_15() == 0.0) {
                                 if (g_lots_1288 > 0.0) {
                                    if (DoublerMultiplier <= 0.0 || DoublerMultiplier == 1.0)
                                       if (DoublerAddition > 0.0) g_lots_1288 = g_order_lots_1320 + DoublerAddition;
                                    if (DoublerMultiplier > 0.0 && DoublerMultiplier != 1.0) {
                                       if (DoublerAddition <= 0.0) g_lots_1288 = g_order_lots_1320 * DoublerMultiplier;
                                       if (DoublerAddition > 0.0) g_lots_1288 = g_order_lots_1320 * DoublerMultiplier + DoublerAddition;
                                    }
                                 } else g_lots_1288 = DoublerLotSize;
                                 if (gd_1224 == 0.0) gd_1224 = NormalizeDouble(Ask, gi_2504);
                                 if (gd_1224 > 0.0)
                                    if (NormalizeDouble(Ask, gi_2504) < gd_1224) gd_1224 = NormalizeDouble(Ask, gi_2504);
                                 gd_1240 = gd_1224 + DoublerRangeFromProfit * gd_2300;
                                 if (NormalizeDouble(Ask, gi_2504) >= gd_1224 + DoublerRangeFromProfit * gd_2300) {
                                    if (OrderSend(Symbol(), OP_BUY, g_lots_1288, NormalizeDouble(Ask, gi_2504), 3, 0, 0, "Doubler Buy", g_magic_1704, 0, CLR_NONE) > 0) {
                                       g_count_1336++;
                                       g_price_1404 = 0;
                                       g_price_1388 = 0;
                                    }
                                 }
                              }
                           } else {
                              gd_1240 = 0;
                              gd_1224 = 0;
                           }
                        }
                     }
                  }
               }
               if (f0_25() > f0_31()) {
                  if (Averaging == TRUE) gi_744 = gi_1816;
                  if (gi_744 >= DoublerStartLevel) {
                     if (DoublerEndLevel == 0 || gi_744 < DoublerEndLevel) {
                        if (DoublerMaxOrder == 0 || g_count_1340 < DoublerMaxOrder) {
                           if (AccountProfit() >= 0.0) {
                              if (f0_0() == 0.0) {
                                 if (g_lots_1296 > 0.0) {
                                    if (DoublerMultiplier <= 0.0 || DoublerMultiplier == 1.0)
                                       if (DoublerAddition > 0.0) g_lots_1296 = g_order_lots_1328 + DoublerAddition;
                                    if (DoublerMultiplier > 0.0 && DoublerMultiplier != 1.0) {
                                       if (DoublerAddition <= 0.0) g_lots_1296 = g_order_lots_1328 * DoublerMultiplier;
                                       if (DoublerAddition > 0.0) g_lots_1296 = g_order_lots_1328 * DoublerMultiplier + DoublerAddition;
                                    }
                                 } else g_lots_1296 = DoublerLotSize;
                                 if (gd_1232 == 0.0) gd_1232 = NormalizeDouble(Bid, gi_2504);
                                 if (gd_1232 > 0.0)
                                    if (NormalizeDouble(Bid, gi_2504) > gd_1232) gd_1232 = NormalizeDouble(Bid, gi_2504);
                                 gd_1248 = gd_1232 - DoublerRangeFromProfit * gd_2300;
                                 if (NormalizeDouble(Bid, gi_2504) <= gd_1232 - DoublerRangeFromProfit * gd_2300) {
                                    if (OrderSend(Symbol(), OP_SELL, g_lots_1296, NormalizeDouble(Bid, gi_2504), 3, 0, 0, "Doubler Sell", g_magic_1704, 0, CLR_NONE) > 0) {
                                       g_count_1340++;
                                       g_price_1412 = 0;
                                       g_price_1396 = 0;
                                    }
                                 }
                              }
                           } else {
                              gd_1248 = 0;
                              gd_1232 = 0;
                           }
                        }
                     }
                  }
               }
               for (g_pos_736 = 0; g_pos_736 < OrdersTotal(); g_pos_736++) {
                  if (OrderSelect(g_pos_736, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol()) {
                     if (OrderMagicNumber() == g_magic_1704) {
                        if (OrderType() == OP_BUY) {
                           g_order_open_price_1524 = OrderOpenPrice();
                           g_order_lots_1320 = OrderLots();
                           gd_1508 += OrderLots();
                           if (DoublerTakeProfit <= 0) gd_1256 = 0;
                           if (DoublerTakeProfit > 0) gd_1256 = g_order_open_price_1524 + DoublerTakeProfit * gd_2300;
                           if (DoublerStopLoss <= 0) gd_1264 = 0;
                           if (DoublerStopLoss > 0) gd_1264 = g_order_open_price_1524 - DoublerStopLoss * gd_2300;
                           if (g_price_1388 == 0.0) g_price_1388 = gd_1256;
                           if (g_price_1404 == 0.0) g_price_1404 = gd_1264;
                           if (!f0_5(OrderStopLoss(), g_price_1404))
                              if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_1404, OrderTakeProfit(), 0, CLR_NONE) == FALSE) g_price_1404 -= gd_2300;
                           if (!f0_5(OrderTakeProfit(), g_price_1388))
                              if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_1404, g_price_1388, 0, CLR_NONE) == FALSE) g_price_1388 += gd_2300;
                        }
                        if (OrderType() == OP_SELL) {
                           g_order_open_price_1532 = OrderOpenPrice();
                           g_order_lots_1328 = OrderLots();
                           gd_1516 += OrderLots();
                           if (DoublerTakeProfit <= 0) gd_1272 = 0;
                           if (DoublerTakeProfit > 0) gd_1272 = g_order_open_price_1532 - DoublerTakeProfit * gd_2300;
                           if (DoublerStopLoss <= 0) gd_1280 = 0;
                           if (DoublerStopLoss > 0) gd_1280 = g_order_open_price_1532 + DoublerStopLoss * gd_2300;
                           if (g_price_1396 == 0.0) g_price_1396 = gd_1272;
                           if (g_price_1412 == 0.0) g_price_1412 = gd_1280;
                           if (!f0_5(OrderStopLoss(), g_price_1412))
                              if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_1412, OrderTakeProfit(), 0, CLR_NONE) == FALSE) g_price_1412 += gd_2300;
                           if (!f0_5(OrderTakeProfit(), g_price_1396))
                              if (OrderModify(OrderTicket(), OrderOpenPrice(), g_price_1412, g_price_1396, 0, CLR_NONE) == FALSE) g_price_1396 -= gd_2300;
                        }
                     }
                  }
               }
            }
         }
         gs_unused_2316 = "";
         gs_unused_2324 = "";
         Sleep(10);
      }
   }
   return (0);
}

bool f0_5(double ad_0, double ad_8) {
   if (NormalizeDouble(ad_0, gi_2504) == NormalizeDouble(ad_8, gi_2504)) return (TRUE);
   return (FALSE);
}

int f0_3(double ad_0, double ad_8) {
   if (ad_0 <= ad_8) gi_2488 = 1;
   if (ad_0 > ad_8) gi_2488 = 2;
   if (gi_2488 != gi_2484) gi_2484 = gi_2488;
   return (gi_2488);
}

int f0_11() {
   g_count_708 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderMagicNumber() != g_magic_1704 && OrderSymbol() == Symbol())
            if (OrderType() == OP_BUYSTOP || OrderType() == OP_BUYLIMIT) g_count_708++;
      }
   }
   return (g_count_708);
}

int f0_8() {
   g_count_712 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderMagicNumber() != g_magic_1704 && OrderSymbol() == Symbol())
            if (OrderType() == OP_SELLSTOP || OrderType() == OP_SELLLIMIT) g_count_712++;
      }
   }
   return (g_count_712);
}

int f0_17() {
   g_count_704 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderMagicNumber() != g_magic_1704 && OrderSymbol() == Symbol())
            if (OrderType() == OP_SELL) g_count_704++;
      }
   }
   return (g_count_704);
}

int f0_29() {
   g_count_700 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderMagicNumber() != g_magic_1704 && OrderSymbol() == Symbol())
            if (OrderType() == OP_BUY) g_count_700++;
      }
   }
   return (g_count_700);
}

double f0_4() {
   double ld_ret_0 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderMagicNumber() != g_magic_1704 && OrderSymbol() == Symbol())
            if (OrderType() == OP_BUY || OrderType() == OP_BUYSTOP) ld_ret_0 += OrderLots();
      }
   }
   return (ld_ret_0);
}

double f0_23() {
   double ld_ret_0 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderMagicNumber() != g_magic_1704 && OrderSymbol() == Symbol())
            if (OrderType() == OP_SELL || OrderType() == OP_SELLSTOP) ld_ret_0 += OrderLots();
      }
   }
   return (ld_ret_0);
}

double f0_9() {
   double ld_ret_0 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderMagicNumber() != g_magic_1704 && OrderSymbol() == Symbol())
            if (OrderType() == OP_BUY || OrderType() == OP_BUYSTOP) ld_ret_0 += 1.0;
      }
   }
   return (ld_ret_0);
}

double f0_6() {
   double ld_ret_0 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderMagicNumber() != g_magic_1704) {
            if (OrderSymbol() == gs_eurusd_300 || OrderSymbol() == gs_usdchf_308)
               if (OrderType() == OP_BUY) ld_ret_0 += 1.0;
         }
      }
   }
   return (ld_ret_0);
}

double f0_1() {
   double ld_ret_0 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderMagicNumber() != g_magic_1704) {
            if (OrderSymbol() == gs_eurusd_300 || OrderSymbol() == gs_usdchf_308)
               if (OrderType() == OP_SELL) ld_ret_0 += 1.0;
         }
      }
   }
   return (ld_ret_0);
}

double f0_24() {
   double ld_ret_0 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderMagicNumber() != g_magic_1704 && OrderSymbol() == Symbol())
            if (OrderType() == OP_SELL || OrderType() == OP_SELLSTOP) ld_ret_0 += 1.0;
      }
   }
   return (ld_ret_0);
}

double f0_13() {
   gd_752 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE)
         if (OrderType() == OP_BUY && OrderSymbol() == Symbol() && OrderMagicNumber() != g_magic_1704) gd_752 += OrderLots();
   }
   return (gd_752);
}

double f0_22() {
   gd_760 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE)
         if (OrderType() == OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() != g_magic_1704) gd_760 += OrderLots();
   }
   return (gd_760);
}

double f0_31() {
   gd_752 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE)
         if (OrderType() == OP_BUY && OrderSymbol() == Symbol()) gd_752 += OrderLots();
   }
   return (gd_752);
}

double f0_25() {
   gd_760 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE)
         if (OrderType() == OP_SELL && OrderSymbol() == Symbol()) gd_760 += OrderLots();
   }
   return (gd_760);
}

double f0_7() {
   g_order_open_price_864 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderMagicNumber() != g_magic_1704)
            if (OrderType() == OP_BUY && OrderSymbol() == Symbol()) g_order_open_price_864 = OrderOpenPrice();
      }
   }
   return (g_order_open_price_864);
}

double f0_14() {
   g_order_open_price_872 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderMagicNumber() != g_magic_1704)
            if (OrderType() == OP_SELL && OrderSymbol() == Symbol()) g_order_open_price_872 = OrderOpenPrice();
      }
   }
   return (g_order_open_price_872);
}

double f0_27() {
   g_order_open_price_1556 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderMagicNumber() == g_magic_1704) break;
         if (!((OrderType() == OP_BUY && OrderSymbol() == Symbol()))) break;
         g_order_open_price_1556 = OrderOpenPrice();
         break;
      }
   }
   return (g_order_open_price_1556);
}

double f0_20() {
   g_order_open_price_1564 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderMagicNumber() == g_magic_1704) break;
         if (!((OrderType() == OP_SELL && OrderSymbol() == Symbol()))) break;
         g_order_open_price_1564 = OrderOpenPrice();
         break;
      }
   }
   return (g_order_open_price_1564);
}

double f0_15() {
   gd_752 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderMagicNumber() == g_magic_1704)
            if (OrderType() == OP_BUY && OrderSymbol() == Symbol()) gd_752 += OrderLots();
      }
   }
   return (gd_752);
}

double f0_0() {
   gd_760 = 0;
   g_order_total_732 = OrdersTotal();
   for (g_pos_736 = 0; g_pos_736 < g_order_total_732; g_pos_736++) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderMagicNumber() == g_magic_1704)
            if (OrderType() == OP_SELL && OrderSymbol() == Symbol()) gd_760 += OrderLots();
      }
   }
   return (gd_760);
}

void f0_19() {
   if (gi_316 == FALSE) {
      if (gi_272 == TRUE) gi_720 = f0_6() + f0_1();
      if (gi_272 == FALSE) gi_720 = f0_29() + f0_17();
      if (gi_716 > gi_720) {
         if (CloseOneCloseAll == TRUE) {
            if (OrdersTotal() > 0) {
               gi_2192 = FALSE;
               f0_2();
            }
            if (gs_1696 == "") gs_1696 = "CloseOneCloseAll";
            if (OrdersTotal() <= 0) f0_26();
         }
         if (CloseOneCloseAll == FALSE) {
            if (f0_11() + f0_8() > 0) f0_21();
            if (f0_29() + f0_17() <= 0) {
               if (OrdersTotal() > 0) {
                  gi_2192 = FALSE;
                  f0_2();
               }
               gs_1696 = "No Open Positions";
               if (OrdersTotal() <= 0) f0_26();
            }
         }
         gi_716 = 0;
      } else gi_716 = gi_720;
   }
   if (gi_316 == TRUE) gi_664 = TRUE;
}

void f0_26() {
   gi_744 = 0;
   gi_1812 = 0;
   gi_1816 = 0;
   gi_1352 = FALSE;
   if (EALoop <= 0) {
      gd_1844 = 0;
      gi_664 = TRUE;
      gi_2192 = TRUE;
   }
   if (EALoop > 0) {
      if (gi_740 < EALoop) {
         gd_1844 = 0;
         gi_740++;
         gi_664 = TRUE;
         gi_2192 = TRUE;
         return;
      }
      Print("Loop End");
      gi_656 = FALSE;
      f0_2();
   }
}

void f0_21() {
   for (g_pos_736 = OrdersTotal() - 1; g_pos_736 >= 0; g_pos_736--) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) != FALSE) {
         if (OrderType() == OP_BUYSTOP) OrderDelete(OrderTicket());
         if (OrderType() == OP_SELLSTOP) OrderDelete(OrderTicket());
         if (OrderType() == OP_BUYLIMIT) OrderDelete(OrderTicket());
         if (OrderType() == OP_SELLLIMIT) OrderDelete(OrderTicket());
      }
   }
}

void f0_2() {
   gi_664 = FALSE;
   Print("Closing All Order...");
   while (true) {
      if (OrdersTotal() <= 0) break;
      f0_12(1);
      f0_12(2);
      f0_12(0);
      f0_12(3);
   }
}

void f0_12(int ai_0) {
   double order_lots_4;
   int ticket_12;
   int error_16;
   int li_20;
   string ls_24;
   double price_32;
   int cmd_40;
   int cmd_44 = -1;
   string ls_48 = Symbol();
   for (g_pos_736 = OrdersTotal() - 1; g_pos_736 >= 0; g_pos_736--) {
      if (OrderSelect(g_pos_736, SELECT_BY_POS) == TRUE) {
         if (ai_0 == 1) {
            if (OrderSymbol() != ls_48) continue;
            cmd_40 = OrderType();
            if (cmd_40 > OP_SELL) continue;
            order_lots_4 = OrderLots();
            ticket_12 = OrderTicket();
            cmd_44 = cmd_40;
            while (true) {
               if (cmd_44 == -1) break;
               switch (cmd_44) {
               case OP_BUY:
                  price_32 = Bid;
                  ls_24 = "Buy";
                  break;
               case OP_SELL:
                  price_32 = Ask;
                  ls_24 = "Sell";
               }
               Print("Attempting to close ", ls_24, " order ", DoubleToStr(order_lots_4, 2), " lot. Awaiting for response..");
               li_20 = OrderClose(ticket_12, order_lots_4, price_32, 3);
               if (li_20 == 1) break;
               error_16 = GetLastError();
               switch (error_16) {
               case 135/* PRICE_CHANGED */:
                  RefreshRates();
                  break;
               case 136/* OFF_QUOTES */:
                  while (RefreshRates() == FALSE) Sleep(1);
                  break;
               case 146/* TRADE_CONTEXT_BUSY */:
                  Sleep(300);
                  RefreshRates();
                  break;
               case 2/* COMMON_ERROR */:
                  Sleep(300);
                  RefreshRates();
                  break;
               case 133/* TRADE_DISABLED */:
                  Sleep(300);
                  RefreshRates();
                  break;
               case 64/* ACCOUNT_DISABLED */:
                  Print("Account is blocked");
                  break;
               default:
               }
               Sleep(10);
               RefreshRates();
            }
         }
         if (ai_0 == 2) {
            if (OrderSymbol() == ls_48) continue;
            cmd_40 = OrderType();
            if (cmd_40 > OP_SELL) continue;
            order_lots_4 = OrderLots();
            ticket_12 = OrderTicket();
            cmd_44 = cmd_40;
            while (true) {
               if (cmd_44 == -1) break;
               switch (cmd_44) {
               case OP_BUY:
                  price_32 = MarketInfo(OrderSymbol(), MODE_BID);
                  ls_24 = "Buy";
                  break;
               case OP_SELL:
                  price_32 = MarketInfo(OrderSymbol(), MODE_ASK);
                  ls_24 = "Sell";
               }
               Print("Attempting to close ", ls_24, " order ", DoubleToStr(order_lots_4, 2), " lot. Awaiting for response..");
               li_20 = OrderClose(ticket_12, order_lots_4, price_32, 3);
               if (li_20 == 1) break;
               error_16 = GetLastError();
               switch (error_16) {
               case 135/* PRICE_CHANGED */:
                  RefreshRates();
                  break;
               case 136/* OFF_QUOTES */:
                  while (RefreshRates() == FALSE) Sleep(1);
                  break;
               case 146/* TRADE_CONTEXT_BUSY */:
                  Sleep(300);
                  RefreshRates();
                  break;
               case 2/* COMMON_ERROR */:
                  Sleep(300);
                  RefreshRates();
                  break;
               case 133/* TRADE_DISABLED */:
                  Sleep(300);
                  RefreshRates();
                  break;
               case 64/* ACCOUNT_DISABLED */:
                  Print("Account is blocked");
                  break;
               default:
               }
               Sleep(10);
               RefreshRates();
            }
         }
         if (ai_0 == 0) {
            if (OrderSymbol() != ls_48) continue;
            cmd_40 = OrderType();
            if (cmd_40 < OP_BUYLIMIT) continue;
            ticket_12 = OrderTicket();
            cmd_44 = cmd_40;
            order_lots_4 = OrderLots();
            while (true) {
               if (cmd_44 == -1) break;
               switch (cmd_44) {
               case OP_BUYLIMIT:
                  ls_24 = "Buy Limit";
                  break;
               case OP_SELLLIMIT:
                  ls_24 = "Sell Limit";
                  break;
               case OP_BUYSTOP:
                  ls_24 = "Buy Stop";
                  break;
               case OP_SELLSTOP:
                  ls_24 = "Sell Stop";
               }
               li_20 = OrderDelete(ticket_12);
               if (li_20 == 1) {
                  Print("Order ", ls_24, " of ", DoubleToStr(order_lots_4, 2), " lot has been closed");
                  break;
               }
               error_16 = GetLastError();
               switch (error_16) {
               case 135/* PRICE_CHANGED */:
                  RefreshRates();
                  break;
               case 136/* OFF_QUOTES */:
                  while (RefreshRates() == FALSE) Sleep(1);
                  break;
               case 146/* TRADE_CONTEXT_BUSY */:
                  Sleep(300);
                  RefreshRates();
                  break;
               case 2/* COMMON_ERROR */:
                  Sleep(300);
                  RefreshRates();
                  break;
               case 133/* TRADE_DISABLED */:
                  Sleep(300);
                  RefreshRates();
                  break;
               case 64/* ACCOUNT_DISABLED */:
                  Print("Account is blocked");
                  break;
               default:
               }
               Sleep(10);
               RefreshRates();
            }
         }
         if (ai_0 == 3) {
            if (OrderSymbol() != ls_48) {
               cmd_40 = OrderType();
               if (cmd_40 >= OP_BUYLIMIT) {
                  ticket_12 = OrderTicket();
                  cmd_44 = cmd_40;
                  order_lots_4 = OrderLots();
                  while (true) {
                     if (cmd_44 == -1) break;
                     switch (cmd_44) {
                     case OP_BUYLIMIT:
                        ls_24 = "Buy Limit";
                        break;
                     case OP_SELLLIMIT:
                        ls_24 = "Sell Limit";
                        break;
                     case OP_BUYSTOP:
                        ls_24 = "Buy Stop";
                        break;
                     case OP_SELLSTOP:
                        ls_24 = "Sell Stop";
                     }
                     li_20 = OrderDelete(ticket_12);
                     if (li_20 == 1) {
                        Print("Order ", ls_24, " of ", DoubleToStr(order_lots_4, 2), " lot has been closed");
                        break;
                     }
                     error_16 = GetLastError();
                     switch (error_16) {
                     case 135/* PRICE_CHANGED */:
                        RefreshRates();
                        break;
                     case 136/* OFF_QUOTES */:
                        while (RefreshRates() == FALSE) Sleep(1);
                        break;
                     case 146/* TRADE_CONTEXT_BUSY */:
                        Sleep(300);
                        RefreshRates();
                        break;
                     case 2/* COMMON_ERROR */:
                        Sleep(300);
                        RefreshRates();
                        break;
                     case 133/* TRADE_DISABLED */:
                        Sleep(300);
                        RefreshRates();
                        break;
                     case 64/* ACCOUNT_DISABLED */:
                        Print("Account is blocked");
                        break;
                     default:
                     }
                     Sleep(10);
                     RefreshRates();
                  }
               }
            }
         }
      }
   }
}

void f0_18() {
   double ima_0;
   double ima_8;
   double ima_16;
   double ima_24;
   double ld_32 = MathRound(NormalizeDouble(Bid, gi_2504) / g_point_2496) * g_point_2496;
   double ld_40 = MathRound(NormalizeDouble(Ask, gi_2504) / g_point_2496) * g_point_2496;
   if (f0_29() + f0_17() <= 0) {
      if (InitialOrder == "auto" || InitialOrder == "a" || gs_1752 == "auto") {
         ima_0 = iMA(Symbol(), 0, ShortEMA, 0, MODE_EMA, PRICE_CLOSE, 0);
         ima_8 = iMA(Symbol(), 0, LongEMA, 0, MODE_EMA, PRICE_CLOSE, 0);
         ima_16 = iMA(Symbol(), 0, ShortEMA, 0, MODE_EMA, PRICE_CLOSE, 1);
         ima_24 = iMA(Symbol(), 0, LongEMA, 0, MODE_EMA, PRICE_CLOSE, 1);
         gi_2492 = f0_3(ima_8, ima_0);
         while (f0_29() + f0_17() <= 0) {
            if (gi_2492 == 1) {
               RefreshRates();
               if (f0_28(OP_BUY, g_lots_1908, Ask, 0, 0, "Auto Buy", MagicNumber) < 0) {
                  Print("Error Buy= ", ErrorDescription(GetLastError()));
                  return;
               }
            }
            if (gi_2492 == 2) {
               RefreshRates();
               if (f0_28(OP_SELL, g_lots_1908, Bid, 0, 0, "Auto Sell", MagicNumber) < 0) {
                  Print("Error Sell = ", ErrorDescription(GetLastError()));
                  return;
               }
            }
         }
         gs_1752 = "auto";
      }
      if (gi_1344 == FALSE) {
         if (InitialOrder == "buy auto" || InitialOrder == "ba") {
            if (gd_1828 != NormalizeDouble(Ask, gi_2504)) gd_1828 = NormalizeDouble(Ask, gi_2504);
            if (f0_28(OP_BUY, g_lots_1908, gd_1828, 0, 0, "Buy", MagicNumber) < 0) {
               Print("Error Buy= ", ErrorDescription(GetLastError()));
               return;
            }
            gi_1344 = TRUE;
            gs_1752 = "auto";
         }
         if (InitialOrder == "sell auto" || InitialOrder == "sa") {
            if (gd_1836 != NormalizeDouble(Bid, gi_2504)) gd_1836 = NormalizeDouble(Bid, gi_2504);
            if (f0_28(OP_SELL, g_lots_1908, gd_1836, 0, 0, "Sell", MagicNumber) < 0) {
               Print("Error Sell= ", ErrorDescription(GetLastError()));
               return;
            }
            gi_1344 = TRUE;
            gs_1752 = "auto";
         }
         if (InitialOrder == "manual" || InitialOrder == "m") {
            gi_1344 = TRUE;
            gs_1752 = "auto";
            gi_664 = FALSE;
            gi_660 = TRUE;
         }
      }
   }
   if (f0_29() + f0_17() > 0) {
      gi_664 = FALSE;
      gi_660 = TRUE;
   }
}

int f0_28(int a_cmd_0, double a_lots_4, double ad_12, int ai_20, int ai_24, string a_comment_28, int a_magic_36) {
   double price_40;
   double price_48;
   double price_56;
   int ticket_64;
   int spread_68;
   color color_72;
   int error_76;
   bool li_80 = FALSE;
   if (!IsStopped()) {
      if (!IsExpertEnabled()) return (-1);
      if (!IsConnected()) return (-1);
      if (IsTradeContextBusy()) {
         Sleep(3000);
         li_80 = TRUE;
//???/*empty:77220:(@)*/
      }
      Print("  ");
      if (li_80) {
         RefreshRates();
         li_80 = FALSE;
      }
      switch (a_cmd_0) {
      case OP_BUY:
         price_40 = NormalizeDouble(Ask, Digits);
         price_48 = f0_16(ai_24 == 0, 0, NormalizeDouble(Ask + ai_24 * Point, Digits));
         price_56 = f0_16(ai_20 == 0, 0, NormalizeDouble(Ask - ai_20 * Point, Digits));
         color_72 = Green;
         break;
      case OP_SELL:
         price_40 = NormalizeDouble(Bid, Digits);
         price_48 = f0_16(ai_24 == 0, 0, NormalizeDouble(Bid - ai_24 * Point, Digits));
         price_56 = f0_16(ai_20 == 0, 0, NormalizeDouble(Bid + ai_20 * Point, Digits));
         color_72 = Fuchsia;
      case OP_BUYSTOP:
         price_40 = NormalizeDouble(ad_12, Digits);
         price_48 = f0_16(ai_24 == 0, 0, NormalizeDouble(price_40 + ai_24 * Point, Digits));
         price_56 = f0_16(ai_20 == 0, 0, NormalizeDouble(price_40 - ai_20 * Point, Digits));
         color_72 = Green;
         break;
      case OP_SELLSTOP:
         price_40 = NormalizeDouble(ad_12, Digits);
         price_48 = f0_16(ai_24 == 0, 0, NormalizeDouble(price_40 - ai_24 * Point, Digits));
         price_56 = f0_16(ai_20 == 0, 0, NormalizeDouble(price_40 + ai_20 * Point, Digits));
         color_72 = Red;
      case OP_BUYLIMIT:
         price_40 = NormalizeDouble(ad_12, Digits);
         price_48 = f0_16(ai_24 == 0, 0, NormalizeDouble(price_40 + ai_24 * Point, Digits));
         price_56 = f0_16(ai_20 == 0, 0, NormalizeDouble(price_40 - ai_20 * Point, Digits));
         color_72 = Blue;
         break;
      case OP_SELLLIMIT:
         price_40 = NormalizeDouble(ad_12, Digits);
         price_48 = f0_16(ai_24 == 0, 0, NormalizeDouble(price_40 - ai_24 * Point, Digits));
         price_56 = f0_16(ai_20 == 0, 0, NormalizeDouble(price_40 + ai_20 * Point, Digits));
         color_72 = Red;
         break;
      default:
         return (-1);
      }
      spread_68 = MarketInfo(Symbol(), MODE_SPREAD);
      if (spread_68 > 3) spread_68 = 3;
      if (IsTradeAllowed()) {
         ticket_64 = OrderSend(Symbol(), a_cmd_0, a_lots_4, price_40, spread_68, price_56, price_48, a_comment_28, a_magic_36, 0, color_72);
         if (ticket_64 < 0) {
            error_76 = GetLastError();
            if (error_76 == 4/* SERVER_BUSY */ || error_76 == 135/* PRICE_CHANGED */ || error_76 == 137/* BROKER_BUSY */ || error_76 == 138/* REQUOTE */ || error_76 == 146/* TRADE_CONTEXT_BUSY */ ||
               error_76 == 136/* OFF_QUOTES */) {
               Print("(OrderSend - ", error_76, "): ", ErrorDescription(error_76));
               Sleep(3000);
               li_80 = TRUE;
//???/*empty:80580:(@)*/
            }
            Print(" (OrderSend - ", error_76, "): ", ErrorDescription(error_76));
         }
      } else {
         Print("      !");
         Sleep(3000);
         li_80 = TRUE;
//???/*empty:80744:(@)*/
      }
   }
   Print("  .  = ", ticket_64);
   return (ticket_64);
}

double f0_16(bool ai_0, double ad_4, double ad_12) {
   if (ai_0) return (ad_4);
   return (ad_12);
}

void f0_10() {
   gd_2036 = NormalizeDouble(OrderOpenPrice() - gi_360 * gd_2300 - gi_336 * gd_2300 - gd_2284, gi_2504);
   if (gd_2084 != NormalizeDouble(Ask, gi_2504)) {
      gd_2084 = NormalizeDouble(Ask, gi_2504);
      return;
   }
   if (NormalizeDouble(Ask, gi_2504) < NormalizeDouble(gd_2036, gi_2504)) {
      if (g_price_1956 == 0.0 || NormalizeDouble(g_price_1956, gi_2504) > NormalizeDouble(Ask + gi_336 * gd_2300 + gd_2284, gi_2504)) {
         g_price_1956 = NormalizeDouble(Ask + gi_336 * gd_2300 + gd_2284, gi_2504);
         Alert("Adjusting Buy Stop from ", DoubleToStr(OrderOpenPrice(), gi_2504), " to ", DoubleToStr(g_price_1956, gi_2504));
         if (OrderModify(OrderTicket(), g_price_1956, 0, 0, 0, CLR_NONE) < FALSE) Print("Error Modifying MS Buy Stop = ", ErrorDescription(GetLastError()));
      }
   }
}

void f0_30() {
   gd_2044 = OrderOpenPrice() + gi_360 * gd_2300 + gi_336 * gd_2300 + gd_2284;
   if (gd_2092 != NormalizeDouble(Bid, gi_2504)) {
      gd_2092 = NormalizeDouble(Bid, gi_2504);
      return;
   }
   if (NormalizeDouble(Bid, gi_2504) > NormalizeDouble(gd_2044, gi_2504)) {
      if (NormalizeDouble(g_price_1964, gi_2504) < NormalizeDouble(Bid - gi_336 * gd_2300 - gd_2284, gi_2504)) {
         g_price_1964 = NormalizeDouble(Bid - gi_336 * gd_2300 - gd_2284, gi_2504);
         Alert("Adjusting Sell Stop from ", DoubleToStr(OrderOpenPrice(), gi_2504), " to ", DoubleToStr(g_price_1964, gi_2504));
         if (OrderModify(OrderTicket(), g_price_1964, 0, 0, 0, CLR_NONE) < FALSE) Print("Error Modifying MS Sell Stop = ", ErrorDescription(GetLastError()));
      }
   }
}